Package: BLMA
Date: 2020-06-22
Type: Package
Title: BLMA: A package for bi-level meta-analysis
Version: 1.37.0
Author: Tin Nguyen <tinn@auburn.edu>, Hung Nguyen <pzb00047@auburn.edu>, and Sorin Draghici <sorin@wayne.edu>
Maintainer: Van-Dung Pham <dvp0001@auburn.edu>
Description: Suit of tools for bi-level meta-analysis. The package can
        be used in a wide range of applications, including general
        hypothesis testings, differential expression analysis,
        functional analysis, and pathway analysis.
biocViews: GeneSetEnrichment, Pathways, DifferentialExpression,
        Microarray
License: GPL (>=2)
Depends: ROntoTools, GSA, PADOG, limma, graph, stats, utils, parallel,
        Biobase, metafor, methods
Suggests: RUnit, BiocGenerics
RoxygenNote: 7.3.1
NeedsCompilation: no
git_url: https://git.bioconductor.org/packages/BLMA
git_branch: devel
git_last_commit: 72ed5fb
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
Packaged: 2026-04-28 21:37:21 UTC; biocbuild

#' @title Load KEGG pathways and names
#' @description Load KEGG pathways and names
#' @param organism organism code. Default value is "hsa" (human)
#' @param updateCache re-download KEGG pathways. Default value is FALSE
#' @return 
#' A list of the following components
#' \itemize{
#' \item \emph{kpg} a list of \code{\link{graphNEL}} objects 
#' encoding the pathway information. 
#' \item \emph{kpn} a named vector of pathway tiles. 
#' The names of the vector are the pathway KEGG IDs.
#' }
#' @author
#' Tin Nguyen and Sorin Draghici
#' @seealso \code{\link{keggPathwayGraphs}}, \code{\link{keggPathwayNames}}
#' @examples
#' x <- loadKEGGPathways()
#' @import ROntoTools 
#' @import graph
#' @export
loadKEGGPathways <- function (organism="hsa", updateCache=FALSE) {
    # pathwayFile <- paste(system.file("data", package="BLMA"), "/KEGGPathways_", organism, ".RData", sep = "") 
    # #pathwayFile <- paste("./inst/data/KEGGPathways_", organism, ".RData", sep = "") 
    # if (updateCache | !file.exists(pathwayFile)) {
    #     kpg <- keggPathwayGraphs(organism = organism, updateCache=updateCache)
    #     kpg <- setEdgeWeights(kpg)
    #     kpg <- setNodeWeights(kpg, defaultWeight = 1)
    #     suppressMessages(kpn <- keggPathwayNames(organism, updateCache = FALSE, verbose = FALSE))
    #     kpn <- kpn[names(kpg)]
    #     #dbInfo=keggInfo("pathway")
    #     #message(paste("Database info:\n", dbInfo, sep =""))
    #     save(kpg, kpn, file=pathwayFile)
    # } else {
    #     load(file=pathwayFile)
    #     #message(paste("Database info:\n", dbInfo, sep =""))
    # }

    kpg <- keggPathwayGraphs(organism = organism, updateCache=updateCache)
    kpg <- setEdgeWeights(kpg)
    kpg <- setNodeWeights(kpg, defaultWeight = 1)
    suppressMessages(kpn <- keggPathwayNames(organism, updateCache = FALSE, verbose = FALSE))
    kpn <- kpn[names(kpg)]
    kpn <- kpn[!is.na(kpn)]
    kpg <- kpg[names(kpn)]

    list(kpg=kpg, kpn=kpn)
}

#' @title Over-representation Analysis
#' @description Calculate p-value for over-representation Analysis
#' @param geneSet a vector of gene names belong to the geneset
#' @param DEGenes a vector of differential expressed genes
#' @param measuredGenes a vector of all genes in the analysis
#' @param minSize the minimum number of DE genes in the geneSet
#' @return 
#' p-value
#' @import stats
#' @export
pORACalc <- function(geneSet, DEGenes, measuredGenes, minSize =0) {
    #minSize is the minimum number of DE genes in the geneSet
    universe <- measuredGenes
    white <- DEGenes
    black <- setdiff(measuredGenes,DEGenes)
    sample <- intersect(measuredGenes,geneSet)
    sampleWhite <- intersect(sample,DEGenes)
    if (length(sampleWhite) < minSize) {
        res <- NA
    } else {
        res <- phyper(q=length(sampleWhite)-1,m=length(white),n=length(black), k=length(sample), lower.tail=FALSE)
    }
    res
}

#' @title Bi-level meta-analysis -- applied to pathway analysis 
#' 
#' @description Perform a bi-level meta-analysis conjunction with 
#' Impact Analysis to integrate multiple gene expression datasets
#' 
#' @param kpg list of pathway graphs as objects of type graph 
#' (e.g., \code{\link{graphNEL}})
#' @param kpn names of the pathways.
#' @param dataList a list of datasets to be combined. Each dataset is a data 
#' frame where the rows are the gene IDs and the columns are the samples.
#' @param groupList a list of vectors. Each vector represents the phenotypes 
#' of the corresponding dataset in dataList, which are either 'c' (control) 
#' or 'd' (disease). 
#' @param splitSize the minimum number of disease samples in each split 
#' dataset. splitSize should be at least 3. By default, splitSize=5
#' @param metaMethod the method used to combine p-values. This should be one 
#' of addCLT (additive method [1]), fisherMethod (Fisher's method [5]), 
#' stoufferMethod (Stouffer's method [6]), max (maxP method [7]), or 
#' min (minP method [8])
#' @param pCutoff cutoff p-value used to identify differentially 
#' expressed (DE) genes. This parameter is used only when the enrichment 
#' method is "ORA". By default, pCutoff=0.05 (five percent)
#' @param percent percentage of genes with highest foldchange to be considered 
#' as differentially expressed (DE). This parameter is used when the enrichment 
#' method is "ORA". By default percent=0.05 (five percent). Please note that 
#' only genes with p-value less than pCutoff will be considered
#' @param nboot number of bootstrap iterations. By default, nboot=200
#' @param seed seed. By default, seed=1.
#' @param mc.cores the number of cores to be used in parallel computing. 
#' By default, mc.cores=1
#' 
#' @details The bi-level framework combines the datasets at two levels: an 
#' intra-experiment analysis, and an inter-experiment analysis [1]. At the 
#' intra-level analysis, the framework splits a dataset into smaller datasets, 
#' performs pathway analysis for each split dataset using 
#' Impact Analysis [2,3], and then combines the results of these split datasets 
#' using \emph{metaMethod}. At the inter-level analysis, the results obtained 
#' for individual datasets are combined using \emph{metaMethod}
#' 
#' @return
#' A data frame (rownames are geneset/pathway IDs) that consists of the 
#' following information:
#' \itemize{
#' \item \emph{Name:} name/description of the corresponding pathway/geneset
#' \item Columns that include the pvalues obtained from the intra-experiment 
#' analysis of individual datasets
#' \item \emph{pBLMA:} p-value obtained from the inter-experiment 
#' analysis using addCLT
#' \item \emph{rBLMA:} ranking of the geneset/pathway using addCLT
#' \item \emph{pBLMA.fdr:} FDR-corrected p-values
#' }
#' 
#' @author
#' Tin Nguyen and Sorin Draghici
#' 
#' @references
#' [1] T. Nguyen, R. Tagett, M. Donato, C. Mitrea, and S. Draghici. A novel 
#' bi-level meta-analysis approach -- applied to biological pathway analysis. 
#' Bioinformatics, 32(3):409-416, 2016.
#' 
#' [2] A. L. Tarca, S. Draghici, P. Khatri, S. S. Hassan, P. Mittal, 
#' J.-s. Kim, C. J. Kim, J. P. Kusanovic, and R. Romero. A novel signaling 
#' pathway impact analysis. Bioinformatics, 25(1):75-82, 2009.
#' 
#' [3] S. Draghici, P. Khatri, A. L. Tarca, K. Amin, A. Done, C. Voichita, 
#' C. Georgescu, and R. Romero. A systems biology approach for pathway 
#' level analysis. Genome Research, 17(10):1537-1545, 2007.
#' 
#' [4] R. A. Fisher. Statistical methods for research workers. 
#' Oliver & Boyd, Edinburgh, 1925.
#' 
#' [5] S. Stouffer, E. Suchman, L. DeVinney, S. Star, and J. Williams, RM. 
#' The American Soldier: Adjustment during army life, volume 1. 
#' Princeton University Press, Princeton, 1949.
#' 
#' [6] L. H. C. Tippett. The methods of statistics. 
#' The Methods of Statistics, 1931.
#' 
#' [7] B. Wilkinson. A statistical consideration in psychological research. 
#' Psychological Bulletin, 48(2):156, 1951.
#' @seealso \code{\link{bilevelAnalysisGeneset}}, \code{\link{pe}}, \code{\link{phyper}}
#'
#' @examples
#' # load KEGG pathways
#' x <- loadKEGGPathways()  
#' 
#' # load example data
#' dataSets <- c("GSE17054", "GSE57194", "GSE33223", "GSE42140")
#' data(list=dataSets, package="BLMA")
#' names(dataSets) <- dataSets
#' dataList <- lapply(dataSets, function(dataset) get(paste0("data_", dataset)))
#' groupList <- lapply(dataSets, function(dataset) get(paste0("group_", dataset)))
#' 
#' IAComb <- bilevelAnalysisPathway(x$kpg, x$kpn, dataList, groupList)
#' head(IAComb[, c("Name", "pBLMA", "pBLMA.fdr", "rBLMA")])
#' 
#' @import ROntoTools 
#' @import graph
#' @import limma
#' @import parallel
#' @import Biobase
#' @import utils
#' @import stats
#' @import methods
#' @export
bilevelAnalysisPathway <- function (kpg, kpn, dataList, groupList, splitSize=5, metaMethod=addCLT, pCutoff=0.05, percent=0.05, mc.cores=1, nboot=200, seed=1) {
    if (splitSize < 3) {
        stop("splitSize should be at least 3")
    }
    
    allGenes <- unique(unlist(lapply(kpg,FUN=function(x){return (x@nodes)})))
    
    Results <- list()
    for (i in 1:length(dataList)) {
        cat("Working on dataset ", names(dataList)[[i]], ", " , ncol(dataList[[i]]), " samples \n", sep="")
        
        data <- dataList[[i]]
        group <- groupList[[i]]
        
        data <- data[rownames(data)%in%allGenes,]
        
        # make sure that we are not dividing by very small number
        if (min(data) < 2) {
            data <- data - min(data) + 2
        }
        
        
        diseases <- names(group)[which(group=="d")]
        
        l <- splitS(diseases, splitSize)

        resList <- mclapply(l, 
                    FUN= function (sample, group, data, kpg) {
                            ret <- rep(1, length(kpg))
                            names(ret) <- names(kpg)
                                 
                            message(paste(sample, collapse=", "))
                                 
                            s <- c(names(group)[which(group=="c")], sample)
                            g <- group[s]
                            d <- data[,names(g)]
                                 
                            gset <- ExpressionSet(as.matrix(d))
                            fl <- as.factor(g)
                            gset$description <- fl
                            design <- model.matrix(~ description + 0, gset)
                            colnames(design) <- levels(fl)
                            fit <- lmFit(gset, design)
                            cont.matrix <- makeContrasts(d-c, levels=design)
                            fit2 <- contrasts.fit(fit, cont.matrix)
                            fit2 <- eBayes(fit2)
                            tT <- topTable(fit2, adjust="none", sort.by="logFC", number=nrow(d)*percent, p.value=pCutoff)
                                 
                            measuredGenes <- rownames(d)
                            geneFC <- tT$logFC; names(geneFC) <- rownames(tT)
                                 
                            a <- capture.output(
                                peRes <- pe(x=geneFC,graphs=kpg, ref=measuredGenes, 
                                        nboot=nboot, seed=seed, verbose=FALSE))
                            res <- Summary(peRes)
                                 
                            if (length(geneFC)<length(measuredGenes)) {
                                ret[rownames(res)] <- as.numeric(res$pComb)
                            } else ret[rownames(res)] <- as.numeric(res$pAcc)
                                 
                            ret
                        }
                        , group=group, data=data, kpg=kpg, mc.cores=mc.cores)
        result <- data.frame(row.names=names(kpg), Names=kpn[names(kpg)])
        result <- cbind(result,do.call(cbind, resList))
        

        if ((1+length(diseases)/splitSize)>=3) {
            result$pIntra <- apply(result[,2:(1+length(diseases)/splitSize)], 1, FUN = metaMethod)
        } else {
            result$pIntra <- result[,2]
        }
        
        Results[[i]] <- result
    }
    
    r <- names(kpn)
    FinalResults <- data.frame(row.names=r, Name=kpn[r])
    for (i in 1:length(dataList)) {
        FinalResults[r, i+1] <- Results[[i]][r,"pIntra"]
    }
    colnames(FinalResults) <- c("Name", names(dataList))
    
    if (length(dataList)>1) {
        FinalResults$pBLMA <- apply(FinalResults[,2:(length(dataList)+1)], 1, FUN = metaMethod) 
    } else {
        FinalResults$pBLMA <- FinalResults[,2]
    }
    FinalResults$rBLMA[order(FinalResults$pBLMA)] <- seq(length(kpg))
    FinalResults$pBLMA.fdr <- p.adjust(FinalResults$pBLMA, method="fdr")
    
    FinalResults <- FinalResults[order(FinalResults$pBLMA),]
    FinalResults
} 

#' @title Bi-level meta-analysis -- applied to geneset enrichment analysis 
#' @description Perform a bi-level meta-analysis in conjunction with 
#' geneset enrichment methods (ORA/GSA/PADOG) to integrate 
#' multiple gene expression datasets.
#' @param gslist a list of gene sets.
#' @param gs.names names of the gene sets.
#' @param dataList a list of datasets to be combined. Each dataset is a 
#' data frame where the rows are the gene IDs and the columns are the samples.
#' @param groupList a list of vectors. Each vector represents the phenotypes 
#' of the corresponding dataset in dataList. 
#' The elements of each vector are either 'c' (control) or 'd' (disease).
#' @param splitSize the minimum number of disease samples in each split 
#' dataset. splitSize should be at least 3. By default, splitSize=5
#' @param metaMethod the method used to combine p-values. This should be one 
#' of addCLT (additive method [1]), fisherMethod (Fisher's method [5]), 
#' stoufferMethod (Stouffer's method [6]), max (maxP method [7]), 
#' or min (minP method [8])
#' @param enrichment the method used for enrichment analysis. This should be 
#' one of "ORA", "GSA", or "PADOG". By default, enrichment is set to "ORA".
#' @param pCutoff cutoff p-value used to identify differentially 
#' expressed (DE) genes. This parameter is used only when the enrichment 
#' method is "ORA". By default, pCutoff=0.05 (five percent)
#' @param percent percentage of genes with highest foldchange to be considered 
#' as differentially expressed (DE). This parameter is used when the 
#' enrichment method is "ORA". By default percent=0.05 (five percent). Please 
#' note that only genes with p-value less than pCutoff will be considered
#' @param mc.cores the number of cores to be used in parallel computing. 
#' By default, mc.cores=1
#' @param ... additional parameters of the GSA/PADOG functions
#' @details The bi-level framework combines the datasets at two levels: 
#' an intra- experiment analysis, and an inter-experiment analysis [1]. At the 
#' intra-level analysis, the framework splits a dataset into smaller datasets, 
#' performs enrichment analysis for each split dataset (using ORA [2], 
#' GSA [3], or PADOG [4]), and then combines the results of these split 
#' datasets using \emph{metaMethod}. At the inter-level analysis, the results 
#' obtained for individual datasets are combined using \emph{metaMethod}
#' @return
#' A data frame (rownames are geneset/pathway IDs) that consists of the 
#' following information:
#' \itemize{
#' \item \emph{Name:} name/description of the corresponding pathway/geneset
#' \item Columns that include the pvalues obtained from the intra-experiment 
#' analysis of individual datasets
#' \item \emph{pBLMA:} p-value obtained from the inter-experiment analysis 
#' using addCLT
#' \item \emph{rBLMA:} ranking of the geneset/pathway using addCLT
#' \item \emph{pBLMA.fdr:} FDR-corrected p-values
#' }
#' @author
#' Tin Nguyen and Sorin Draghici
#' @references
#' [1] T. Nguyen, R. Tagett, M. Donato, C. Mitrea, and S. Draghici. A novel 
#' bi-level meta-analysis approach -- applied to biological pathway analysis. 
#' Bioinformatics, 32(3):409-416, 2016.
#' 
#' [2] S. Draghici, P. Khatri, R. P. Martin, G. C. Ostermeier, and 
#' S. A. Krawetz. Global functional profiling of gene expression. 
#' Genomics, 81(2):98-104, 2003.
#' 
#' [3] B. Efron and R. Tibshirani. On testing the significance of sets of 
#' genes. The Annals of Applied Statistics, 1(1):107-129, 2007.
#' 
#' [4] A. L. Tarca, S. Draghici, G. Bhatti, and R. Romero. Down-weighting 
#' overlapping genes improves gene set analysis. 
#' BMC Bioinformatics, 13(1):136, 2012.
#' 
#' [5] R. A. Fisher. Statistical methods for research workers. 
#' Oliver & Boyd, Edinburgh, 1925.
#' 
#' [6] S. Stouffer, E. Suchman, L. DeVinney, S. Star, and J. Williams, RM. 
#' The American Soldier: Adjustment during army life, volume 1. 
#' Princeton University Press, Princeton, 1949.
#' 
#' [7] L. H. C. Tippett. The methods of statistics. 
#' The Methods of Statistics, 1931.
#' 
#' [8] B. Wilkinson. A statistical consideration in psychological research. 
#' Psychological Bulletin, 48(2):156, 1951.
#' @seealso \code{\link{bilevelAnalysisPathway}}, \code{\link{phyper}}, \code{\link{GSA}}, \code{\link{padog}}
#' @examples 
#' # load KEGG pathways and create gene sets
#' x <- loadKEGGPathways()
#' gslist <- lapply(x$kpg,FUN=function(y){return (nodes(y));})
#' gs.names <- x$kpn[names(gslist)]
#' 
#' # load example data
#' dataSets <- c("GSE17054", "GSE57194", "GSE33223", "GSE42140")
#' data(list=dataSets, package="BLMA")
#' names(dataSets) <- dataSets
#' dataList <- lapply(dataSets, function(dataset) get(paste0("data_", dataset)))
#' groupList <- lapply(dataSets, function(dataset) get(paste0("group_", dataset)))
#' # perform bi-level meta-analysis in conjunction with ORA
#' ORAComb <- bilevelAnalysisGeneset(gslist, gs.names, dataList, groupList, enrichment = "ORA")
#' head(ORAComb[, c("Name", "pBLMA", "pBLMA.fdr", "rBLMA")])
#' 
#' # perform bi-level meta-analysis in conjunction with GSA
#' GSAComb <- bilevelAnalysisGeneset(gslist, gs.names, dataList, groupList, enrichment = "GSA", nperms = 200, random.seed = 1)
#' head(GSAComb[, c("Name", "pBLMA", "pBLMA.fdr", "rBLMA")])
#' 
#' # perform bi-level meta-analysi in conjunction with PADOG
#' set.seed(1)
#' PADOGComb <- bilevelAnalysisGeneset(gslist, gs.names, dataList, groupList, enrichment = "PADOG", NI=200)
#' head(PADOGComb[, c("Name", "pBLMA", "pBLMA.fdr", "rBLMA")])
#' 
#' @import GSA
#' @import PADOG
#' @import limma
#' @import stats
#' @import parallel
#' @import Biobase
#' @import utils
#' @export
bilevelAnalysisGeneset <- function (gslist, gs.names, dataList, groupList, splitSize=5, metaMethod=addCLT, enrichment = "ORA", pCutoff=0.05, percent=0.05, mc.cores=1, ...) {  
    if (splitSize < 3) {
        stop("splitSize should be at least 3")
    }
    if (!is.element(enrichment, c("GSA","PADOG","ORA"))) {
        stop("enrichment must be GSA, PADOG, or ORA")
    }
    
    allGenes <- unique(unlist(gslist))
    
    Results <- list()
    for (i in 1:length(dataList)) {
        cat("Working on dataset ", names(dataList)[[i]], ", " , ncol(dataList[[i]]), " samples \n", sep="")
        
        data <- dataList[[i]]
        group <- groupList[[i]]
        
        data <- data[rownames(data)%in%allGenes,]
        group <- sort(group)
        data <- data[,names(group)]
        
        diseases <- paste(names(group)[which(group=="d")])
        
        l <- splitS(diseases, splitSize)
        
        resList <- mclapply(l, 
            FUN = function (sample, group, data, gslist) {
                ret <- rep(NA, length(gslist))
                names(ret) <- names(gslist)
                
                message(paste(sample, collapse=", "))
                
                s <- c(names(group)[which(group=="c")], sample)
                g <- group[s]
                d <- data[,names(g)]
                
                if (enrichment == "GSA") {
                    x <- as.character(g); x[x=="c"] <- 1; x[x=="d"] <- 2; x <- as.numeric(x)
                    a <- capture.output(resgsa <- GSA(x = as.matrix(d), y = x, 
                                 genesets = gslist, 
                                 genenames = rownames(data),
                                 resp.type = "Two class unpaired", 
                                 ...))
                    
                    ret <- 2 * apply(cbind(resgsa$pvalues.lo, 
                                          resgsa$pvalues.hi), 1, min)
                } else if (enrichment == "PADOG") {
                    a <- capture.output(respadog <- padog(
                        esetm=as.matrix(d),
                        group=g,
                        gslist=gslist,
                        gs.names=gs.names,
                        ...))
                    
                    ret[rownames(respadog)] <- as.numeric(paste(respadog[,"Ppadog"]))
                } else if (enrichment == "ORA") {
                          
                    gset <- ExpressionSet(as.matrix(d))
                    fl <- as.factor(g)
                    gset$description <- fl
                    design <- model.matrix(~ description + 0, gset)
                    colnames(design) <- levels(fl)
                    fit <- lmFit(gset, design)
                    cont.matrix <- makeContrasts(d-c, levels=design)
                    fit2 <- contrasts.fit(fit, cont.matrix)
                    fit2 <- eBayes(fit2)
                    tT <- topTable(fit2, adjust="none", sort.by="logFC", number=nrow(d)*percent, p.value=pCutoff)
                    
                    measuredGenes <- rownames(d)
                    DEGenes <- rownames(tT[tT$p])
                    
                    resORA <- unlist(lapply(gslist, FUN=pORACalc, DEGenes = DEGenes, measuredGenes = measuredGenes))
                    
                    ret[names(resORA)] <- resORA
                }
            
                ret
            }
            , group=group, data=data, gslist=gslist, mc.cores=mc.cores)
        
        result <- data.frame(row.names=names(gslist), Names=gs.names[names(gslist)])
        result <- cbind(result,do.call(cbind, resList))
        
        if ((1+length(diseases)/splitSize)>=3) {
            result$pIntra <- apply(result[,2:(1+length(diseases)/splitSize)], 1, FUN = metaMethod)
        } else {
            result$pIntra <- result[,2]
        }
        Results[[i]] <- result
    }
    
    r <- names(gslist)
    FinalResults <- data.frame(row.names=r, Name=gs.names[r])
    for (i in 1:length(dataList)) {
        FinalResults[r, i+1] <- Results[[i]][r,"pIntra"]
    }
    colnames(FinalResults) <- c("Name", names(dataList))
    
    if (length(dataList)>1) {
        FinalResults$pBLMA <- apply(FinalResults[,2:(length(dataList)+1)], 1, FUN = metaMethod) 
    } else {
        FinalResults$pBLMA <- FinalResults[,2]
    }
    FinalResults$rBLMA[order(FinalResults$pBLMA)] <- seq(length(gslist))
    FinalResults$pBLMA.fdr <- p.adjust(FinalResults$pBLMA, method="fdr")
    
    FinalResults <- FinalResults[order(FinalResults$pBLMA),]
    FinalResults
}





#' Gene expression dataset GSE17054 from Majeti et al.
#' @name GSE17054
#' @aliases 
#' data_GSE17054
#' group_GSE17054
#' @docType data
#' @description This dataset consists of 5 acute myeloid leukemia and 
#' 4 control samples. The data frame data_GSE17054 includes the expression data 
#' while the vector group_GSE17054 includes the grouping information.
#' @references 
#' Majeti et al. Dysregulated gene expression networks in human acute 
#' myelogenous leukemia stem cells. Proceedings of the National Academy of 
#' Sciences, 106(9):3396-3401, 2009.
#' @source 
#' Obtained from \url{http://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE17054}
#' 
#' @usage data(GSE17054)
#' @format data_GSE17054 is a data frame with 4738 rows and 9 columns. 
#' The rows represent the genes and the columns represent the samples.
#' 
#' group_GSE17054 is a vector that represents the sample grouping for data_GSE17054. 
#' The elements of \emph{group_GSE17054} are either 'c' (control) or 'd' (disease). 
#' @keywords dataset
NULL



#' Gene expression dataset GSE57194 from Abdul-Nabi et al.
#' @name GSE57194
#' @aliases 
#' data_GSE57194
#' group_GSE57194
#' @docType data
#' @description This dataset consists of 6 acute myeloid leukemia and 
#' 6 control samples. The data frame data_GSE57194 includes the expression data 
#' while the vector group_GSE57194 includes the grouping information.
#' @references 
#' Abdul-Nabi et al. In vitro transformation of primary human CD34+ cells by 
#' AML fusion oncogenes: early gene expression profiling reveals possible drug 
#' target in AML. PLoS One, 5(8):e12464, 2010.
#' @source
#' Obtained from \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE57194}
#' @usage data(GSE57194)
#' @format data_GSE57194 is a data frame with 4114 rows and 12 columns. 
#' The rows represent the genes and the columns represent the samples.
#' 
#' group_GSE57194 is a vector that represents the sample grouping for data_GSE57194. 
#' The elements of \emph{group_GSE57194} are either 'c' (control) or 'd' (disease). 
#' @keywords dataset
NULL



#' Gene expression dataset GSE33223 from Bacher et al.
#' @name GSE33223
#' @aliases 
#' data_GSE33223
#' group_GSE33223
#' @docType data
#' @description This dataset consists of 20 acute myeloid leukemia and 
#' 10 control samples. The data frame data_GSE33223 includes the expression data 
#' while the vector group_GSE33223 includes the grouping information.
#' @references 
#' Bacher et al. Multilineage dysplasia does not influence prognosis in 
#' CEBPA-mutated AML, supporting the WHO proposal to classify these patients 
#' as a unique entity. Blood, 119(20):4719-22, 2012.
#' @source 
#' Obtained from \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE33223}
#' @usage data(GSE33223)
#' @format data_GSE33223 is a data frame with 4114 rows and 30 columns. 
#' The rows represent the genes and the columns represent the samples.
#' 
#' group_GSE33223 is a vector that represents the sample grouping for 
#' data_GSE33223. The elements of \emph{group_GSE33223} are either 
#' 'c' (control) or 'd' (disease). 
#' @keywords dataset
NULL


#' The gene expression dataset GSE42140 obtained from Gene Expression Omnibus
#' @name GSE42140
#' @aliases 
#' data_GSE42140
#' group_GSE42140
#' @docType data
#' @description This dataset consists of 26 acute myeloid leukemia and 
#' 5 control samples. The data frame data_GSE42140 includes the expression data 
#' while the vector group_GSE42140 includes the grouping information.
#' @references \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE42140}
#' @usage data(GSE42140)
#' @format data_GSE42140 is a data frame with 4114 rows and 31 columns. 
#' The rows represent the genes and the columns represent the samples.
#' 
#' group_GSE42140 is a vector that represents the sample grouping for data_GSE42140. 
#' The elements of \emph{group_GSE42140} are either 'c' (control) or 'd' (disease). 
#' @keywords dataset
NULL

test_loadKEGGPathways <- function() {
    x=loadKEGGPathways()
    checkIdentical(names(x$kpg), names(x$kpn))
}

test_bilevelAnalysisGeneset <- function() {
    dataSets=c("GSE17054")
    data(list=dataSets, package="BLMA")
    dataList <- list()
    groupList <- list()
    for (i in 1:length(dataSets)) {
        dataset=dataSets[i]
        group <- get(paste("group_",dataset,sep=""))
        data=get(paste("data_",dataset,sep=""))
        dataList[[i]] = data
        groupList[[i]] = group
    }
    names(dataList)=names(groupList)=dataSets
    
    # load KEGG pathways and create gene sets
    x=loadKEGGPathways()
    gslist=lapply(x$kpg,FUN=function(y){return (nodes(y));})
    gs.names=x$kpn[names(gslist)]
    
    ORAComb=bilevelAnalysisGeneset(gslist = gslist, gs.names = gs.names, 
            dataList = dataList, groupList = groupList, enrichment = "ORA")
    
    GSAComb=bilevelAnalysisGeneset(gslist = gslist, gs.names = gs.names, 
            dataList = dataList, groupList = groupList, enrichment = "GSA", 
            mc.cores=1, nperms=200, random.seed = 1)
    
    PADOGComb=bilevelAnalysisGeneset(gslist = gslist, gs.names = gs.names, 
            dataList = dataList, groupList = groupList, enrichment = "PADOG", 
            mc.cores=1, NI=200)
    
    checkEqualsNumeric(dim(ORAComb),dim(GSAComb))
    checkEqualsNumeric(dim(ORAComb),dim(PADOGComb))
}

test_bilevelAnalysisPathway <- function() {
    dataSets=c("GSE17054")
    data(list=dataSets, package="BLMA")
    dataList <- list()
    groupList <- list()
    for (i in 1:length(dataSets)) {
        dataset=dataSets[i]
        group <- get(paste("group_",dataset,sep=""))
        data=get(paste("data_",dataset,sep=""))
        dataList[[i]] = data
        groupList[[i]] = group
    }
    names(dataList)=names(groupList)=dataSets
    
    x=loadKEGGPathways() 
    IAComb=bilevelAnalysisPathway(kpg = x$kpg, kpn = x$kpn, dataList = dataList, 
                                  groupList = groupList, mc.cores = 1)
    
    checkTrue(setequal(rownames(IAComb),names(x$kpg)))
}

#' @title Intergrative genes statistic
#' @description Calculate genes summary statistic across multiple datasets
#' 
#' @param allGenes Vector of all genes names for the analysis.
#' @param dataList A list of expression matrices, in which rows are genes and columns are samples.
#' @param groupList A list of vectors indicating sample group corresponding with expression matrices in dataList.
#' @param ncores Number of core to use in prallel processing.
#' @param method Function for combining p-values. It must accept one input which is a vector of p-values and return a combined p-value. Three methods are embeded in this package are addCLT, fisherMethod, and stoufferMethod.
#' 
#' @details 
#' 
#' To estimate the effect sizes of genes across all studies, first standardized mean difference 
#' for each gene in individual studies is compute. Next, the overall efect size and standard error are estimated using
#' the random-efects model. This overall efect size represents the gene's expression change under the efect of
#' the condition. The, z-scores and p-values of observing such efect sizes are computed. The p-values is obtained 
#' from classical hypothesis testing. By default, linear model and empirical Bayesian testing \(limma\) are used 
#' to compute the p-values for diferential expression. The two-tailed p-values are converted to one-tailed p-values (lef- and right-tailed). 
#' For each gene, the one-tailed p-values across all datasets are then combined using the addCLT, stouffer or fisher method.
#' These p-values represent how likely the diferential expression is observed by chance.
#' 
#' @return A data.frame of gene statistics with following columns:
#' 
#' \describe{
#'   \item{pTwoTails}{Two-tailed p-values}
#'   \item{pTwoTails.fdr}{Two-tailed p-values with false discovery rate correction}
#'   \item{pLeft}{left-tailed p-values}
#'   \item{pLeft.fdr}{left-tailed p-values with false discovery rate correction}
#'   \item{pRight.fdr}{right-tailed p-values with false discovery rate correction}
#'   \item{pRight}{right-tailed p-values}
#'   \item{ES}{Effect size}
#'   \item{ES.pTwoTails}{Two-tailed p-values for effect size}
#'   \item{ES.pTwoTails.fdr}{Two-tailed p-values for effect size with false discovery rate correction}
#'   \item{ES.pLeft}{Left-tailed p-values for effect size}
#'   \item{ES.pLeft.fdr}{Left-tailed p-values for effect size with false discovery rate correction}
#'   \item{ES.pRight}{Right-tailed p-values for effect size}
#'   \item{ES.pRight.fdr}{Right-tailed p-values for effect size with false discovery rate correction}
#' }
#' 
#' @author Tin Nguyen, Hung Nguyen, and Sorin Draghici
#' 
#' @references
#' 
#' Nguyen, T., Shafi, A., Nguyen, T. M., Schissler, A. G., & Draghici, S. (2020). NBIA: a network-based integrative analysis framework-applied to pathway analysis. Scientific reports, 10(1), 1-11.
#' Nguyen, T., Tagett, R., Donato, M., Mitrea, C., & Draghici, S. (2016). A novel bi-level meta-analysis approach: applied to biological pathway analysis. Bioinformatics, 32(3), 409-416.
#' Smyth, G. K. (2005). Limma: linear models for microarray data. In Bioinformatics and computational biology solutions using R and Bioconductor (pp. 397-420). Springer, New York, NY.
#' 
#' @seealso \code{\link{addCLT}}
#' 
#' @examples
#' 
#' datasets <- c("GSE17054", "GSE57194", "GSE33223", "GSE42140")
#' data(list = datasets, package = "BLMA")
#' dataList <- lapply(datasets, function(dataset) {
#'     get(paste0("data_", dataset))
#' })
#' groupList <- lapply(datasets, function(dataset) {
#'     get(paste0("group_", dataset))
#' })
#' names(dataList) <- datasets
#' names(groupList) <- datasets
#' 
#' allGenes <- Reduce(intersect, lapply(dataList, rownames))
#' 
#' geneStat <- getStatistics(allGenes, dataList, groupList)
#' head(geneStat)
#' 
#' # perform pathway analysis
#' library(ROntoTools)
#' # get gene network
#' kpg <- loadKEGGPathways()$kpg
#' # get gene network name
#' kpn <- loadKEGGPathways()$kpn
#' # get geneset
#' gslist <- lapply(kpg,function(y) nodes(y))
#' 
#' # get differential expressed genes
#' DEGenes.Left <- rownames(geneStat)[geneStat$pLeft < 0.05 & geneStat$ES.pLeft < 0.05]
#' DEGenes.Right <- rownames(geneStat)[geneStat$pRight < 0.05 & geneStat$ES.pRight < 0.05]
#' 
#' DEGenes <- union(DEGenes.Left, DEGenes.Right)
#' 
#' # perform pathway analysis with ORA
#' oraRes <- lapply(gslist, function(gs){
#'     pORACalc(geneSet = gs, DEGenes = DEGenes, measuredGenes = rownames(geneStat))
#' })
#' oraRes <- data.frame(p.value = unlist(oraRes), pathway = names(oraRes))
#' rownames(oraRes)  <- kpn[rownames(oraRes)]
#' 
#' # print results
#' print(head(oraRes))
#' 
#' # perfrom pathway analysis with Pathway-Express from ROntoTools
#' ES <- geneStat[DEGenes, "ES"]
#' names(ES) <- DEGenes
#'
#' peRes = pe(x = ES, graphs = kpg, ref = allGenes, nboot = 1000, seed=1)
#' 
#' peRes.Summary <- Summary(peRes, comb.pv.func = fisherMethod)
#' peRes.Summary[, ncol(peRes.Summary) + 1] <- rownames(peRes.Summary)
#' rownames(peRes.Summary) <- kpn[rownames(peRes.Summary)]
#' colnames(peRes.Summary)[ncol(peRes.Summary)] = "pathway"
#' 
#' # print results
#' print(head(peRes.Summary))
#' 
#' @import limma
#' @import metafor
#' @export 
getStatistics <- function (allGenes, dataList, groupList, ncores = 1, method=addCLT) {
    # calculate left and right p-values
    pValue.Left <- pValue.Right <- data.frame(row.names=allGenes)
    for (i in 1:length(dataList)){
        dataset=names(dataList)[i]
        
        data <- dataList[[i]]
        group <- groupList[[i]]
        
        data=data[rownames(data)%in%allGenes,]
        
        gset=ExpressionSet(as.matrix(data))
        fl <- as.factor(group)
        gset$description <- fl
        design <- model.matrix(~ description + 0, gset)
        colnames(design) <- levels(fl)
        fit <- lmFit(gset, design)
        cont.matrix <- makeContrasts(d-c, levels=design)
        fit2 <- contrasts.fit(fit, cont.matrix)
        fit2 <- eBayes(fit2, 0.01)
        tT <- topTable(fit2, adjust="fdr", sort.by="B", number=Inf)
        tT$P.Left = ifelse(tT$logFC <0, tT$P.Value/2, 1-tT$P.Value/2)
        tT$P.Right = ifelse(tT$logFC >0, tT$P.Value/2, 1-tT$P.Value/2)
        pValue.Left[rownames(tT),dataset] <- tT[,"P.Left"]
        pValue.Right[rownames(tT),dataset] <- tT[,"P.Right"]
    }
    pValue.Left$pAddCLT <- apply(pValue.Left[,1:length(dataList)], FUN = function(x) {method(na.omit(x))}, MARGIN = 1)
    pValue.Right$pAddCLT <- apply(pValue.Right[,1:length(dataList)], FUN = function(x) {method(na.omit(x))}, MARGIN = 1)
    
    
    controlSize <- controlMean <- controlStd <- data.frame(row.names=allGenes)
    diseaseSize <- diseaseMean <- diseaseStd <- data.frame(row.names=allGenes)
    for (i in 1:length(dataList)){
        dataset=names(dataList)[i]
        
        data <- dataList[[i]]
        group <- groupList[[i]]
        
        data=data[rownames(data)%in%allGenes,]
        
        controlDat = data[,names(group)[group=="c"]]
        diseaseDat = data[,names(group)[group=="d"]]
        
        controlSize[rownames(controlDat), dataset] <- ncol(controlDat)
        diseaseSize[rownames(diseaseDat), dataset] <- ncol(diseaseDat)
        
        controlMean[rownames(controlDat), dataset] <- apply(controlDat, FUN=mean, MARGIN = 1)
        diseaseMean[rownames(diseaseDat), dataset] <- apply(diseaseDat, FUN=mean, MARGIN = 1)
        
        controlStd[rownames(controlDat), dataset] <- apply(controlDat, FUN=sd, MARGIN = 1)
        diseaseStd[rownames(diseaseDat), dataset] <- apply(diseaseDat, FUN=sd, MARGIN = 1)
    }
    
    fc=mclapply(allGenes, FUN=calculateFC, 
                controlSize=controlSize, controlMean=controlMean, controlStd=controlStd,
                diseaseSize=diseaseSize, diseaseMean=diseaseMean, diseaseStd=diseaseStd,
                mc.cores=ncores)
    names(fc) <- allGenes
    effectSizes <- unlist(lapply(fc,FUN=function(x){x$beta}))
    pValues <- unlist(lapply(fc,FUN=function(x){x$pval}))
    
    mRNAStats = data.frame(row.names = allGenes, pLeft=pValue.Left[allGenes,]$pAddCLT, 
                           pRight=pValue.Right[allGenes,]$pAddCLT, 
                           ES=effectSizes[allGenes], ES.pTwoTails=pValues[allGenes])
    mRNAStats$pTwoTails=2*apply(mRNAStats[,c("pLeft","pRight")], FUN=min, MARGIN = 1)
    mRNAStats$ES.pLeft = ifelse(mRNAStats$ES <0, mRNAStats$ES.pTwoTails/2, 1-mRNAStats$ES.pTwoTails/2)
    mRNAStats$ES.pRight = ifelse(mRNAStats$ES >0, mRNAStats$ES.pTwoTails/2, 1-mRNAStats$ES.pTwoTails/2)
    mRNAStats$pLeft.fdr=p.adjust(mRNAStats$pLeft,method="fdr")
    mRNAStats$pRight.fdr=p.adjust(mRNAStats$pRight,method="fdr")
    mRNAStats$pTwoTails.fdr=p.adjust(mRNAStats$pTwoTails,method="fdr")
    mRNAStats$ES.pLeft.fdr=p.adjust(mRNAStats$ES.pLeft,method="fdr")
    mRNAStats$ES.pRight.fdr=p.adjust(mRNAStats$ES.pRight,method="fdr")
    mRNAStats$ES.pTwoTails.fdr=p.adjust(mRNAStats$ES.pTwoTails,method="fdr")
    
    mRNAStats
}


getSimilarityFromGrouping <- function(g) {
    N=length(g)
    S=matrix(0,N,N)
    colnames(S)=rownames(S)=names(g)
    for (j in unique(g)){
        X=rep(0,N);
        X[which(g==j)]=1
        S=S+X%*%t(X)
    }
    S
}

hierClustering <- function(data, method=km, minSize=40) {
    group <- rep(1, nrow(data));names(group) <- rownames(data)
    elements <- rownames(data)
    myGap <- clusGap(data[elements,],FUNcluster=method, K.max=2, B=50)
    split= length(elements)>minSize & maxSE(myGap$Tab[,"gap"], myGap$Tab[,"SE.sim"], method="globalSEmax")>1
    while (split==TRUE) {
        g <- method(data[elements,], 2)$cluster + max(group)
        group[elements] <- g
        
        split <- FALSE
        for (i in sort(unique(group))) {
            elements = names(group)[which(group==i)]
            if (length(elements)>minSize) {
                myGap <- clusGap(data[elements,],FUNcluster=method, K.max=2, B=50)
                if (maxSE(myGap$Tab[,"gap"], myGap$Tab[,"SE.sim"], method="globalSEmax")>1) {
                    split <- TRUE
                    break
                }
            }
        }
        
    }
    
    group <- as.numeric(as.factor(group))
    names(group) <- rownames(data)
    
    group
}

getCommonGenes <- function(dataList, minGeneCount=3) {
    allGenes=NULL
    for (i in 1:length(dataList)) {
        data <- dataList[[i]]
        allGenes=union(allGenes, rownames(data))
    }
    
    dsCounts <- rep(0, length(allGenes))
    names(dsCounts) <- allGenes
    for (i in 1:length(dataList)) {
        data <- dataList[[i]]
        dsCounts[rownames(data)] <- dsCounts[rownames(data)] +1
    } 
    
    allGenes <- names(dsCounts)[dsCounts>=minGeneCount]
    
    allGenes
}

pORACalc=function(DEGeneNames,measuredGenes,geneSet,minSize) {
    universe=measuredGenes
    white=DEGeneNames
    black=setdiff(measuredGenes,DEGeneNames)
    sample=intersect(measuredGenes,geneSet)
    sampleWhite=intersect(sample,DEGeneNames)
    if (length(sampleWhite)<minSize) {res=NA}
    else {
        res=phyper(q=length(sampleWhite)-1,m=length(white),n=length(black),k=length(sample), lower.tail=FALSE)
    }
    res
}

calculateFC = function(gInd, controlSize, controlMean, controlStd, diseaseSize, diseaseMean, diseaseStd) {
    # get dataset names without NA
    ds=controlSize[gInd,]
    ds=names(ds)[!is.na(ds)]
    
    tmp=data.frame(Study=seq(length(ds)),Source=ds, 
                   n1i=as.numeric(diseaseSize[gInd,ds]), m1i=as.numeric(diseaseMean[gInd,ds]), sd1i=as.numeric(diseaseStd[gInd,ds]), 
                   n2i=as.numeric(controlSize[gInd,ds]), m2i=as.numeric(controlMean[gInd,ds]), sd2i=as.numeric(controlStd[gInd,ds]))
    
    tmp1=escalc(measure="SMD", m1i=m1i, sd1i=sd1i, n1i=n1i,m2i=m2i, sd2i=sd2i, n2i=n2i, data=tmp)
    
    res <- try(rma.uni(yi, vi, data=tmp1, control=list(stepadj=0.5,maxiter=10000), method="REML"),silent=TRUE)
    res
}

### R code from vignette source 'BLMA.Rnw'

###################################################
### code chunk number 1: BLMA.Rnw:114-142
###################################################
# one-sample tests
library(BLMA)
set.seed(1)
x <- rnorm(10, mean = 0)
# one-sample left-tailed t-test
t.test(x, mu=1, alternative = "less")$p.value
# one-sample left-tailed intra-experiment analysis with t-test
intraAnalysisClassic(x, func=t.test, mu=1, alternative = "less")
# one-sample right-tailed t-test
t.test(x, mu=1, alternative = "greater")$p.value
# one-sample right-tailed intra-experiment analysis with t-test
intraAnalysisClassic(x, func=t.test, mu=1, alternative = "greater")
# one-sample two-tailed t-test
t.test(x, mu=1)$p.value
# one-sample two-tailed intra-experiment analysis with t-test
intraAnalysisClassic(x, func=t.test, mu=1)
# one-sample left-tailed Wilcoxon test
wilcox.test(x, mu=1, alternative = "less")$p.value
# one-sample left-tailed intra-experiment analysis with Wilcoxon test
intraAnalysisClassic(x, func=wilcox.test, mu=1, alternative = "less")
# one-sample right-tailed Wilcoxon test
wilcox.test(x, mu=1, alternative = "greater")$p.value
# one-sample right-tailed intra-experiment analysis with Wilcoxon test
intraAnalysisClassic(x, func=wilcox.test, mu=1, alternative = "greater")
# one-sample two-tailed Wilcoxon test
wilcox.test(x, mu=1)$p.value
# one-sample two-tailed intra-experiment analysis with Wilcoxon test
intraAnalysisClassic(x, func=wilcox.test, mu=1)


###################################################
### code chunk number 2: BLMA.Rnw:147-162
###################################################
# two-sample tests
set.seed(1)
x <- rnorm(20, mean=0); y=rnorm(20, mean=1)
# two-sample left-tailed t-test
t.test(x,y,alternative="less")$p.value
# two-sample left-tailed intra-experiment analysis with t-test
intraAnalysisClassic(x, y, func=t.test, alternative = "less")
# two-sample right-tailed t-test
t.test(x,y,alternative="greater")$p.value
# two-sample right-tailed intra-experiment analysis with t-test
intraAnalysisClassic(x, y, func=t.test, alternative = "greater")
# two-sample two-tailed t-test
t.test(x,y)$p.value
# two-sample two-tailed intra-experiment analysis with t-test
intraAnalysisClassic(x, y, func=t.test)


###################################################
### code chunk number 3: BLMA.Rnw:168-189
###################################################
# one-sample tests
set.seed(1)
l1 <- lapply(as.list(seq(3)),FUN=function (x) rnorm(n=10, mean=1))
l0 <- lapply(as.list(seq(3)),FUN=function (x) rnorm(n=10, mean=0))
# one-sample right-tailed t-test
lapply(l1, FUN=function(x) t.test(x, alternative="greater")$p.value)
# combining the p-values of one-sample t-test:
addCLT(unlist(lapply(l1, FUN=function(x) 
    t.test(x, alternative="greater")$p.value)))
#Bi-level meta-analysis with one-sample right-tailed t-test
bilevelAnalysisClassic(x=l1, func=t.test, alternative="greater")
# two-sample left-tailed t-test
lapply(seq(l1), FUN=function(i,l1,l0) 
    t.test(l1[[i]], l0[[i]], alternative="greater")$p.value, l1, l0)
# combining the p-values of one-sample t-test:
addCLT(unlist(lapply(seq(l1), FUN=function(i,l1,l0) 
    t.test(l1[[i]], l0[[i]], alternative="greater")$p.value, l1, l0)))
#Bi-level meta-analysis with two-sample right-tailed t-test
bilevelAnalysisClassic(x=l1, y=l0, func=t.test, alternative="greater")
#Bi-level meta-analysis with two-sample left-tailed t-test
bilevelAnalysisClassic(x=l1, y=l0, func=t.test, alternative="less")


###################################################
### code chunk number 4: BLMA.Rnw:232-253
###################################################
library(BLMA)
# load KEGG pathways and create genesets
x=loadKEGGPathways()
gslist <- lapply(x$kpg,FUN=function(y){return (nodes(y));})
gs.names <- x$kpn[names(gslist)]

# load the 4 AML datasets
dataSets <- c("GSE17054", "GSE57194", "GSE33223", "GSE42140")
data(list=dataSets, package="BLMA")

# prepare dataList and groupList
names(dataSets) <- dataSets
dataList <- lapply(dataSets, function(dataset) get(paste0("data_", dataset)))
groupList <- lapply(dataSets, function(dataset) get(paste0("group_", dataset)))

# perform bi-level meta-analysis in conjunction with ORA
system.time(ORAComb <- bilevelAnalysisGeneset(gslist, gs.names, dataList, 
                                              groupList, enrichment = "ORA"))
#print the results
options(digits=2)
head(ORAComb[, c("Name", "pBLMA", "pBLMA.fdr", "rBLMA")])


###################################################
### code chunk number 5: BLMA.Rnw:268-275
###################################################
# perform bi-level meta-analysis in conjunction with GSA
system.time(GSAComb <- bilevelAnalysisGeneset(gslist, gs.names, dataList, 
                                            groupList, enrichment = "GSA", 
                                            nperms=200, random.seed = 1))
#print the results
options(digits=2)
head(GSAComb[, c("Name", "pBLMA", "pBLMA.fdr", "rBLMA")])


###################################################
### code chunk number 6: BLMA.Rnw:288-294
###################################################
set.seed(1)
system.time(PADOGComb <- bilevelAnalysisGeneset(gslist, gs.names, dataList, 
                                    groupList, enrichment = "PADOG", NI=200))
#print the results
options(digits=2)
head(PADOGComb[, c("Name", "pBLMA", "pBLMA.fdr", "rBLMA")])


###################################################
### code chunk number 7: BLMA.Rnw:304-309
###################################################
x <- loadKEGGPathways()  
system.time(IAComb <- bilevelAnalysisPathway(x$kpg, x$kpn, dataList, groupList))
#print the results
options(digits=2)
head(IAComb[, c("Name", "pBLMA", "pBLMA.fdr", "rBLMA")])


###################################################
### code chunk number 8: BLMA.Rnw:337-355
###################################################
#perform intra-experiment analysis of the dataset GSE33223 using addCLT
library(BLMA)
data(GSE33223)
system.time(X <- intraAnalysisGene(data_GSE33223, group_GSE33223))
X <- X[order(X$pIntra), ]
# top 10 genes
head(X)
# bottom 10 genes
tail(X)

#perform intra-experiment analysis of GSE33223 using Fisher's method
system.time(Y <- intraAnalysisGene(data_GSE33223, group_GSE33223, 
                      metaMethod=fisherMethod))
Y = Y[order(Y$pIntra), ]
# top 10 genes
head(Y)
# bottom 10 genes
tail(Y)


###################################################
### code chunk number 9: BLMA.Rnw:367-373
###################################################
system.time(Z <- bilevelAnalysisGene(dataList = dataList, groupList = groupList))

# top 10 genes
head(Z)
# bottom 10 genes
tail(Z)


###################################################
### code chunk number 10: BLMA.Rnw:380-387
###################################################
allGenes <- Reduce(intersect, lapply(dataList, rownames))
system.time(geneStat <- getStatistics(allGenes, dataList = dataList, groupList = groupList))

# top 10 genes
head(Z)
# bottom 10 genes
tail(Z)


###################################################
### code chunk number 11: BLMA.Rnw:391-392
###################################################
?getStatistics


###################################################
### code chunk number 12: BLMA.Rnw:396-433
###################################################
library(ROntoTools)
# get gene network
kpg <- loadKEGGPathways()$kpg
# get gene network name
kpn <- loadKEGGPathways()$kpn
# get geneset
gslist <- lapply(kpg,function(y) nodes(y))

# get differential expressed genes
DEGenes.Left <- rownames(geneStat)[geneStat$pLeft < 0.05 & geneStat$ES.pLeft < 0.05]
DEGenes.Right <- rownames(geneStat)[geneStat$pRight < 0.05 & geneStat$ES.pRight < 0.05]

DEGenes <- union(DEGenes.Left, DEGenes.Right)

# perform pathway analysis with ORA
oraRes <- lapply(gslist, function(gs){
    pORACalc(geneSet = gs, DEGenes = DEGenes, measuredGenes = rownames(geneStat))
})
oraRes <- data.frame(p.value = unlist(oraRes), pathway = names(oraRes))
rownames(oraRes)  <- kpn[rownames(oraRes)]

# print results
print(head(oraRes))

# perfrom pathway analysis with Pathway-Express from ROntoTools
ES <- geneStat[DEGenes, "ES"]
names(ES) <- DEGenes

peRes = pe(x = ES, graphs = kpg, ref = allGenes, nboot = 1000, seed=1, verbose = F)

peRes.Summary <- Summary(peRes, comb.pv.func = fisherMethod)
peRes.Summary[, ncol(peRes.Summary) + 1] <- rownames(peRes.Summary)
rownames(peRes.Summary) <- kpn[rownames(peRes.Summary)]
colnames(peRes.Summary)[ncol(peRes.Summary)] = "pathway"

# print results
print(head(peRes.Summary))

#' @title Intra-experiment analysis in conjunction with classical 
#' hypothesis tests
#' @description Perform an intra-experiment analysis in conjunction with any 
#' of the classical hypothesis testing methods, such as t-test, 
#' Wilcoxon test, etc.
#' @param x a numeric vector of data values
#' @param y an optional numeric vector of values
#' @param splitSize the minimum number of size in each split sample. 
#' splitSize should be at least 3. By default, splitSize=5
#' @param metaMethod the method used to combine p-values. This should be one 
#' of addCLT (additive method [1]), fishersMethod (Fisher's method [5]), 
#' stoufferMethod (Stouffer's method [6]), max (maxP method [7]), 
#' or min (minP method [8])
#' @param func the name of the hypothesis test. By default func=t.test
#' @param p.value the component that returns the p-value after performing 
#' the test provided by the \emph{func} parameter. For example, the function 
#' t-test returns the class "htest" where the component "p.value" is the 
#' p-value of the test. By default, p.value="p.value"
#' @param ... additional parameters for \emph{func}
#' @details This function performs an intra-experiment analysis for the given 
#' sample(s) [1]. Given x as the numeric vector, this function first splits x 
#' into smaller samples with size \emph{splitSize}, performs hypothesis 
#' testing using \emph{func}, and then combines the p-values 
#' using \emph{metaMethod}
#' @return
#' intra-experiment p-value
#' @author
#' Tin Nguyen and Sorin Draghici
#' @references
#' [1] T. Nguyen, R. Tagett, M. Donato, C. Mitrea, and S. Draghici. A novel 
#' bi-level meta-analysis approach -- applied to biological pathway analysis. 
#' Bioinformatics, 32(3):409-416, 2016.
#' 
#' @seealso \code{\link{bilevelAnalysisClassic}}, \code{\link{intraAnalysisGene}}, \code{\link{bilevelAnalysisGene}}
#' @examples
#' set.seed(1)
#' x <- rnorm(10, mean = 0)

#' # p-value obtained from a one-sample t-test
#' t.test(x, mu=1, alternative = "less")$p.value
#' # p-value obtained from an intra-experiment analysis
#' intraAnalysisClassic(x, func=t.test, mu=1, alternative = "less")
#' 
#' # p-value obtained from a one-sample wilcoxon test
#' wilcox.test(x, mu=1, alternative = "less")$p.value
#' # p-value obtained from an intra-experiment analysis
#' intraAnalysisClassic(x, func=wilcox.test, mu=1, alternative = "less")
#' 
#' set.seed(1)
#' x <- rnorm(20, mean=0); y <- rnorm(20, mean=1)

#' # p-value obtained from a two-sample t-test
#' t.test(x,y,alternative="less")$p.value
#' # p-value obtained from an intra-experiment analysis
#' intraAnalysisClassic(x, y, func=t.test, alternative = "less")

#' # p-value obtained from a two-sample wilcoxon test
#' wilcox.test(x,y,alternative="less")$p.value
#' # p-value obtained from an intra-experiment analysis
#' intraAnalysisClassic(x, y, func=wilcox.test, alternative = "less")
#' 
#' @import stats
#' @export
intraAnalysisClassic <- function(x, y=NULL, splitSize=5, metaMethod=addCLT, func=t.test, p.value="p.value", ...) {
    if (splitSize < 3) {
        stop("splitSize should be at least 3")
    }
    
    ret <- NULL
    
    l <- splitS(x, splitSize)
    
    retList <- lapply(l, 
                      FUN=function(z, y, func) {
                          func(z , y, ...)[p.value]
                      }, y=y, func=func)
    
    metaMethod(unlist(retList))
}

#' @title Bi-level meta-analysis in conjunction with a classical 
#' hypothesis testing method
#' @description Perform a bi-level meta-analysis in conjunction with any of 
#' the classical hypothesis testing methods, such as t-test, Wilcoxon test, etc.
#' @param x a list of numeric vectors
#' @param y an optional list of numeric vectors
#' @param splitSize the minimum number of size in each split sample. 
#' splitSize should be at least 3. By default, splitSize=5
#' @param metaMethod the method used to combine p-values. This should be one 
#' of addCLT (additive method [1]), fishersMethod (Fisher's method [5]), 
#' stoufferMethod (Stouffer's method [6]), max (maxP method [7]), 
#' or min (minP method [8])
#' @param func the name of the hypothesis test. By default func=t.test
#' @param p.value the component that returns the p-value after performing the 
#' test provided by the \emph{func} parameter. For example, the function 
#' t-test returns the class "htest" where the component "p.value" is the 
#' p-value of the test. By default, p.value="p.value"
#' @param ... additional parameters for \emph{func}
#' @details This function performs a bi-level meta-analysis for the lists 
#' of samples [1]. It performs intra-experiment analyses to compare the 
#' vectors in x agains the corresponding vectors in y using the function 
#' \code{\link{intraAnalysisClassic}} in conjunction with the test provided 
#' in \emph{func}. For example, it compares the first vector in x with the 
#' first vector in y, the second vector in x with the second vector in y, etc. 
#' When y is null, then the comparisons are reduced to one-sample tests. After 
#' these comparisons, we have a list of p-values, one for each comparision. 
#' The function then combines these p-values to obtain a single p-value 
#' using \emph{metaMethod}.
#' @return
#' the combined p-value
#' @author
#' Tin Nguyen and Sorin Draghici
#' @references
#' [1] T. Nguyen, R. Tagett, M. Donato, C. Mitrea, and S. Draghici. A novel 
#' bi-level meta-analysis approach -- applied to biological pathway analysis. 
#' Bioinformatics, 32(3):409-416, 2016.
#' 
#' @seealso \code{\link{intraAnalysisClassic}}, \code{\link{intraAnalysisGene}}, \code{\link{bilevelAnalysisGene}}
#' @examples
#' set.seed(1)
#' l1 <- lapply(as.list(seq(3)),FUN=function (x) rnorm(n=10, mean=1))
#' l1
#' # one-sample t-test
#' lapply(l1, FUN=function(x) t.test(x, alternative="greater")$p.value)
#' # combining the p-values of one-sample t-tests:
#' addCLT(unlist(lapply(l1, FUN=function(x) t.test(x, alter="g")$p.value)))
#' #Bi-level meta-analysis
#' bilevelAnalysisClassic(x=l1, alternative="greater")
#' @import stats
#' @export
bilevelAnalysisClassic <- function(x, y=NULL, splitSize=5, metaMethod=addCLT, func=t.test, p.value="p.value", ...) {
    if (splitSize < 3) {
        stop("splitSize should be at least 3")
    }
    
    metaMethod(sapply(seq(x),FUN=function(i) intraAnalysisClassic(x[[i]], 
                y[[i]], splitSize, metaMethod, func, p.value, ...)))
}



#' @title Intra-experiment analysis of an expression dataset at the gene-level
#' @description perform an intra-experiment analysis in conjunction with 
#' the moderated t-test (limma package) for the purpose of differential 
#' expression analysis of a gene expression dataset
#' @param data a data frame where the rows are the gene IDs and the 
#' columns are the samples
#' @param group sample grouping. The elements of \emph{group} are 
#' either 'c' (control) or 'd' (disease). names(group) should be 
#' identical to colnames(data)
#' @param splitSize the minimum number of disease samples in each split 
#' dataset. splitSize should be at least 3. By default, splitSize=5
#' @param metaMethod the method used to combine p-values. This should be one 
#' of addCLT (additive method [1]), fishersMethod (Fisher's method [5]), 
#' stoufferMethod (Stouffer's method [6]), max (maxP method [7]), 
#' or min (minP method [8])
#' @details This function performs an intra-experiment analysis [1] for 
#' individual genes of the given dataset. The function first splits the 
#' dataset into smaller datasets, performs a moderated t-test (limma package) 
#' for the genes of the split datasets, 
#' and then combines the p-values for individual genes using \emph{metaMethod}
#' @return
#' A data frame (rownames are gene IDs) that consists of the 
#' following information:
#' \itemize{
#' \item \emph{logFC:} log foldchange (diseases versus controls)
#' \item \emph{pLimma:} p-value obtained from limma without spliting
#' \item \emph{pLimma.fdr:} FDR-corrected p-values of pLimma
#' \item \emph{pIntra:} p-value obtained from intra-experiment analysis
#' \item \emph{pIntra.fdr:} FDR-corrected p-values of pIntra
#' }
#' @author
#' Tin Nguyen and Sorin Draghici
#' @references
#' [1] T. Nguyen, R. Tagett, M. Donato, C. Mitrea, and S. Draghici. A novel 
#' bi-level meta-analysis approach -- applied to biological pathway analysis. 
#' Bioinformatics, 32(3):409-416, 2016.
#' 
#' @seealso \code{\link{bilevelAnalysisGene}}, \code{\link{intraAnalysisClassic}}, \code{link{bilevelAnalysisClassic}}
#' @examples
#' data(GSE33223)
#' X <- intraAnalysisGene(data_GSE33223, group_GSE33223)
#' head(X)
#' 
#' @import limma
#' @import stats
#' @import Biobase
#' @export
intraAnalysisGene <- function (data, group, splitSize=5, metaMethod=addCLT) {
    if (splitSize < 3) {
        stop("splitSize should be at least 3")
    }
        
    group <- group[order(group)]
    data <- data[,names(group)]
    
    diseases <- paste(names(group)[which(group=="d")])
    
    l <- splitS(diseases, splitSize)
    
    resList <- lapply(l, 
                    FUN= function (sample, group, data) {
                        ret=rep(NA, nrow(data))
                        names(ret)=rownames(data)
                            
                        s=c(names(group)[which(group=="c")], sample)
                        g=group[s]
                        d=data[,names(g)]
                                     
                        gset=ExpressionSet(as.matrix(d))
                        fl <- as.factor(g)
                        gset$description <- fl
                        design <- model.matrix(~ description + 0, gset)
                        colnames(design) <- levels(fl)
                        fit <- lmFit(gset, design)
                        cont.matrix <- makeContrasts(d-c, levels=design)
                        fit2 <- contrasts.fit(fit, cont.matrix)
                        fit2 <- eBayes(fit2)
                        tT <- topTable(fit2, adjust="none", sort.by="none", number=Inf)
                                 
                        ret[rownames(tT)] = tT$P.Value
                         }
                        , group=group, data=data)
    
    result <- data.frame(row.names=rownames(data))
    result <- cbind(result,do.call(cbind, resList))
    result$pIntra <- apply(result, 1, FUN = metaMethod)
    
    gset <- ExpressionSet(as.matrix(data))
    fl <- as.factor(group)
    gset$description <- fl
    design <- model.matrix(~ description + 0, gset)
    colnames(design) <- levels(fl)
    fit <- lmFit(gset, design)
    cont.matrix <- makeContrasts(d-c, levels=design)
    fit2 <- contrasts.fit(fit, cont.matrix)
    fit2 <- eBayes(fit2)
    tT <- topTable(fit2, adjust="none", sort.by="none", number=Inf)

    FinalResult <- data.frame(row.names=rownames(data))
    FinalResult$logFC <-  tT$logFC
    FinalResult$pLimma <-  tT$P.Value
    FinalResult$pLimma.fdr <- p.adjust(FinalResult$pLimma,method = "fdr")
    FinalResult$pIntra <- result$pIntra
    FinalResult$pIntra.fdr <- p.adjust(FinalResult$pIntra,method = "fdr")
    FinalResult
}

#' @title Bi-level meta-analysis of multiple expression datasets at the 
#' gene-level
#' @description Perform a bi-level meta-analysis in conjunction with the 
#' moderate t-test (limma package) for the purpose of 
#' differential expression analysis of multiple gene expression datasets
#' @param dataList a list of datasets. Each dataset is a data frame where the 
#' rows are the gene IDs and the columns are the samples
#' @param groupList a list of vectors. Each vector represents the phenotypes 
#' of the corresponding dataset in dataList, 
#' which are either 'c' (control) or 'd' (disease). 
#' @param splitSize the minimum number of disease samples in each split 
#' dataset. splitSize should be at least 3. By default, splitSize=5
#' @param metaMethod the method used to combine p-values. This should be one 
#' of addCLT (additive method [1]), 
#' fishersMethod (Fisher's method [5]), stoufferMethod (Stouffer's method [6]), 
#' max (maxP method [7]), or min (minP method [8])
#' @details The bi-level framework combines the datasets at two levels: an 
#' intra- experiment analysis, and an inter-experiment analysis [1]. At the 
#' intra-experiment analysis, the framework splits a dataset into 
#' smaller datasets, performs a moderated t-test (limma package) on split 
#' datasets, and then combines p-values of individual genes 
#' using \emph{metaMethod}. At the inter-experiment analysis, the p-values 
#' obtained for each individual datasets are combined using \emph{metaMethod}
#' @return
#' A data frame containing the following components:
#' \itemize{
#' \item \emph{rownames:} gene IDs that are common in all datasets
#' \item \emph{pLimma:} the p-values obtained by combining pLimma 
#' values of individual datasets
#' \item \emph{pLimma.fdr:} FDR-corrected p-values of pLimma
#' \item \emph{pBilevel:} the p-values obtained from combining pIntra 
#' values of individual datasets
#' \item \emph{pBilevel.fdr:} FDR-corrected p-values of pBilevel
#' }
#' @author
#' Tin Nguyen and Sorin Draghici
#' @references
#' [1] T. Nguyen, R. Tagett, M. Donato, C. Mitrea, and S. Draghici. A novel 
#' bi-level meta-analysis approach -- applied to biological pathway analysis. 
#' Bioinformatics, 32(3):409-416, 2016.
#' 
#' @seealso \code{\link{bilevelAnalysisGene}}, \code{\link{intraAnalysisClassic}}
#' @examples
#' dataSets <- c("GSE17054", "GSE57194", "GSE33223", "GSE42140")
#' data(list=dataSets, package="BLMA")
#' names(dataSets) <- dataSets
#' dataList <- lapply(dataSets, function(dataset) get(paste0("data_", dataset)))
#' groupList <- lapply(dataSets, function(dataset) get(paste0("group_", dataset)))
#' Z <- bilevelAnalysisGene(dataList = dataList, groupList = groupList)
#' head(Z)
#' 
#' @import stats
#' @import Biobase
#' @import stats
#' @export
bilevelAnalysisGene <- function (dataList, groupList, splitSize=5, metaMethod=addCLT) {
    retList <- lapply(as.list(seq(length(dataList))), 
                FUN = function (i, dataList, groupList, metaMethod) {
                    cat("Working on dataset ", names(dataList)[[i]], ", " , ncol(dataList[[i]]), " samples \n", sep="")
                    
                    intraAnalysisGene(dataList[[i]], groupList[[i]], splitSize=splitSize, metaMethod=metaMethod)
                }, dataList=dataList, groupList=groupList, metaMethod=metaMethod)
    
    names(retList) <- names(dataList)
    
    genes <- Reduce(intersect, lapply(dataList, FUN=rownames))
    pTableLimma <- data.frame(row.names=genes)
    for (i in 1:length(dataList)) {
        pTableLimma[,i] <- retList[[i]][genes,"pLimma"]
    }
    
    pTableIntra <- data.frame(row.names=genes)
    for (i in 1:length(dataList)) {
        pTableIntra[,i] <- retList[[i]][genes,"pIntra"]
    }
    
    Result <- data.frame(row.names=genes, pLimma=apply(pTableLimma, 1, FUN = metaMethod), 
                        pBilevel=apply(pTableIntra, 1, FUN = metaMethod))
    Result$pLimma.fdr <- p.adjust(Result$pLimma, method="fdr")
    Result$pBilevel.fdr <- p.adjust(Result$pBilevel, method="fdr")
    Result <- Result[c(1,3,2,4)]
    Result <- Result[order(Result$pBilevel),]
    Result
}

test_intraAnalysisClassic <- function() {
    x <- rnorm(10, mean = 0)
    a <- intraAnalysisClassic(x, func=t.test, mu=1, alternative = "less")
    l=list(x[1:5],x[6:10])
    b=addCLT(unlist(lapply(l, FUN=function(x) t.test(x, mu=1, alternative="less")$p.value)))
    checkEquals(a,b)
}

test_bilevelAnalysisClassic <- function() {
    l1 = lapply(as.list(seq(3)),FUN=function (x) rnorm(n=10, mean=1))
    a=addCLT(unlist(lapply(l1, FUN=intraAnalysisClassic, alternative="greater")))
    b=bilevelAnalysisClassic(x=l1, alternative="greater")
    checkEquals(a,b)
}

test_intraAnalysisGene <- function() {
    data(GSE17054)
    data = data_GSE17054
    group=group_GSE17054
    X = intraAnalysisGene(data, group)
    checkEquals(rownames(data),rownames(X))
}

test_bilevelAnalysisGene <- function() {
    data(GSE17054)
    data = data_GSE17054
    group=group_GSE17054
    dataList=list(data)
    groupList=list(group)
    names(dataList)=names(groupList)="GSE17054"
    a=intraAnalysisGene(data, group)
    a=a[order(a$pIntra),]
    b=bilevelAnalysisGene(dataList = dataList, groupList = groupList)
    checkEqualsNumeric(a$pIntra,b$pBilevel)
}

#' @title Fisher's method for meta-analysis
#' @description Combine independent p-values using the minus log product
#' 
#' @param x is an array of independent p-values
#' 
#' @details
#' 
#' Considering a set of \emph{m} independent significance tests, the resulted 
#' p-values are independent and uniformly distributed between \emph{0} and 
#' \emph{1} under the null hypothesis. Fisher's method uses the minus 
#' log product of the p-values as the summary statistic, which follows a 
#' chi-square distribution with \emph{2m} degrees of freedom. 
#' This chi-square distribution is used to calculate the combined p-value.
#' 
#' @return
#' 
#' combined p-value
#' 
#' @author
#' 
#' Tin Nguyen and Sorin Draghici
#' 
#' @references
#' 
#' [1] R. A. Fisher. Statistical methods for research workers. 
#' Oliver & Boyd, Edinburgh, 1925.
#' 
#' @seealso \code{\link{stoufferMethod}}, \code{\link{addCLT}}
#' 
#' @examples
#' 
#' x <- rep(0,10)
#' fisherMethod(x)
#' 
#' x <- runif(10)
#' fisherMethod(x)
#' 
#' @import stats
#' @export 
fisherMethod <- function(x) {
    if(sum(is.na(x))>0) NA
    else pchisq(-2 * sum(log(x)), df=2*length(x), lower=FALSE)
}


#' @title Stouffer's method for meta-analysis
#' @description Combine independent studies using the sum of p-values 
#' transformed into standard normal variables
#' 
#' @param x is an array of independent p-values
#' 
#' @details
#' 
#' Considering a set of \emph{m} independent significance tests, the resulted 
#' p-values are independent and uniformly distributed between \emph{0} and 
#' \emph{1} under the null hypothesis. Stouffer's method is similar to 
#' Fisher's method (\link{fisherMethod}), with the difference is that it 
#' uses the sum of p-values transformed into standard normal variables 
#' instead of the log product.
#' 
#' @return
#' 
#' combined p-value
#' 
#' @author
#' 
#' Tin Nguyen and Sorin Draghici
#' 
#' @references
#' 
#' [1] S. Stouffer, E. Suchman, L. DeVinney, S. Star, and R. M. Williams. 
#' The American Soldier: Adjustment during army life, volume 1. 
#' Princeton University Press, Princeton, 1949.
#' 
#' @seealso \code{\link{fisherMethod}}, \code{\link{addCLT}}
#' 
#' @examples
#' 
#' x <- rep(0,10)
#' stoufferMethod(x)
#' 
#' x <- runif(10)
#' stoufferMethod(x)
#' 
#' @import stats
#' @export 
stoufferMethod <- function(x) {
    if(sum(is.na(x))>0) NA
    else pnorm(sum(qnorm(x)) / sqrt(length(x)))
}

#x is a vector of p-values
IrwinHallDensity <- function(x) {
    n <- length(x)
    s <- sum(x)
    1/factorial(n-1) * sum(sapply(0:floor(s), 
                function(k) (-1)^k * choose(n,k) * (s-k)^(n-1)))
}

#x is a vector of p-values
IrwinHallCumulative <- function(x) {
    n <- length(x)
    s <- sum(x)
    1/factorial(n) * sum(sapply(0:floor(s), 
                function(k) (-1)^k * choose(n,k) * (s-k)^(n)))
}


additiveMethod <- function(x) {
    #x is a vector of p-values
    n <- length(x)
    if (n <= 20) {
        IrwinHallCumulative(x)
    } else {
        pnorm(sum(x),n/2,sqrt(n/12),lower=TRUE)
    }
}

#x is a vector of p-values
averageDensity <- function(x) {
    n <- length(x)
    a <- mean(x)
    n/factorial(n-1) * sum(sapply(0:floor(n*a), 
                function(k) (-1)^k * choose(n,k) * (n*a-k)^(n-1)))
}

#x is a vector of p-values
averageCumulative <- function(x) {
    n <- length(x)
    a <- mean(x)
    1/factorial(n) * sum(sapply(0:floor(n*a), 
                function(k) (-1)^k * choose(n,k) * (n*a-k)^(n)))
}




#' @title The additive method for meta-analysis
#' @description Combine independent studies using the average of p-values
#' 
#' @param x is an array of independent p-values
#' 
#' @details
#' 
#' This method is based on the fact that sum of independent uniform variables 
#' follow the Irwin-Hall distribution [1a,1b]. When the number of p-values 
#' is small (\emph{n<20}), the distribution of the average of p-values can 
#' be calculated using a linear transformation of the Irwin-Hall distribution.
#' When \emph{n} is large, the distribution is approximated using the 
#' Central Limit Theorem to avoid underflow/overflow problems [2,3,4,5]. 
#' 
#' @return
#' 
#' combined p-value
#' 
#' @author
#' 
#' Tin Nguyen and Sorin Draghici
#' 
#' @references
#' 
#' [1a] P. Hall. The distribution of means for samples of size n drawn from a 
#' population in which the variate takes values between 0 and 1, all such 
#' values being equally probable. Biometrika, 19(3-4):240-244, 1927.
#' 
#' [1b] J. O. Irwin. On the frequency distribution of the means of samples 
#' from a population having any law of frequency with finite moments, with 
#' special reference to Pearson's Type II. Biometrika, 19(3-4):225-239, 1927.
#' 
#' [2] T. Nguyen, R. Tagett, M. Donato, C. Mitrea, and S. Draghici. A novel 
#' bi-level meta-analysis approach -- applied to biological pathway analysis. 
#' Bioinformatics, 32(3):409-416, 2016.
#' 
#' [3] T. Nguyen, C. Mitrea, R. Tagett, and S. Draghici. DANUBE: Data-driven 
#' meta-ANalysis using UnBiased Empirical distributions -- applied to 
#' biological pathway analysis. Proceedings of the IEEE, PP(99):1-20, 2016.
#' 
#' [4] T. Nguyen, D. Diaz, R. Tagett, and S. Draghici. Overcoming the 
#' matched-sample bottleneck: an orthogonal approach to integrate omic data. 
#' Scientific Reports, 6:29251, 2016.
#' 
#' [5] T. Nguyen, D. Diaz, and S. Draghici. TOMAS: A novel TOpology-aware 
#' Meta-Analysis approach applied to System biology. In Proceedings of the 
#' 7th ACM International Conference on Bioin- formatics, Computational Biology, 
#' and Health Informatics, pages 13-22. ACM, 2016.
#' 
#' @seealso \code{\link{fisherMethod}}, \code{\link{stoufferMethod}}
#' 
#' @examples
#' 
#' x <- rep(0,10)
#' addCLT(x)
#' 
#' x <- runif(10)
#' addCLT(x)
#' 
#' @import stats
#' @export 
addCLT <- function(x) {
    if(sum(is.na(x))>0) NA
    else {
        n <- length(x)
        if (n <= 20) {
            averageCumulative(x)
        } else {
            pnorm(mean(x),1/2,sqrt(1/(12*n)),lower=TRUE)
        }  
    }
}



splitS <- function(x, splitSize=5) {
    g <- ceiling(seq(x)/splitSize)
    g[g==floor(length(x)/splitSize)+1] <- floor(length(x)/splitSize)
    split(x, g)
}

test_fisherMethod <- function() {
    checkEquals(fisherMethod(rep(0,10)),0)
    checkEquals(fisherMethod(rep(1,10)),1)
    checkEquals(fisherMethod(c(0,1)),0)
}

test_stoufferMethod <- function() {
    checkEquals(stoufferMethod(rep(0,10)),0)
    checkEquals(stoufferMethod(rep(1,10)),1)
}

test_addCLT <- function() {
    checkEquals(addCLT(rep(0,10)),0)
    checkEquals(addCLT(rep(1,10)),1)
    checkEquals(addCLT(c(rep(0,10),rep(1,10))),0.5)
}

%\VignetteIndexEntry{BLMA}
%\VignetteKeywords{Gene Set Analysis, Pathway Analysis, Meta-analysis, Classical Hypothesis Testing, Differential Expression Analysis}
%\VignettePackage{BLMA}

\documentclass[11pt]{article}

\usepackage{hyperref}
\usepackage[margin=1in]{geometry}
\usepackage{mathtools}
\DeclarePairedDelimiter\ceil{\lceil}{\rceil}
\DeclarePairedDelimiter\floor{\lfloor}{\rfloor}
\newcommand{\sgn}{\text{sgn}}


\newcommand{\Rfunction}[1]{{\texttt{#1}}}
\newcommand{\Rmethod}[1]{{\texttt{#1}}}

\newcommand{\Robject}[1]{{\texttt{#1}}}
\newcommand{\Rpackage}[1]{{\textit{#1}}}
\newcommand{\Rclass}[1]{{\textit{#1}}}


\begin{document}
\SweaveOpts{concordance=TRUE}
\title{BLMA: A package for bi-level meta-analysis}
\author{Tin Nguyen, Hung Nguyen and Sorin Draghici\\
Department of Computer Science, Wayne State University, Detroit MI 48202}
\maketitle

\begin{abstract}
This package provides a bi-level meta-analysis (BLMA) framework that can be 
applied in a wide range of applications: functional analysis, pathway analysis, 
differential expression analysis, and general hypothesis testing. 
The framework is able to integrate multiple studies to gain more statistical 
power, and can be used in conjunction with any statistical hypothesis testing 
method. It exploits not only the vast number of studies performed in 
independent laboratories, but also makes better use of the available number 
of samples within individual studies. In this document, we provide example code 
that applies BLMA in all of the areas mentioned above. 
 
\end{abstract}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\tableofcontents

\clearpage

\section{Introduction}
This document provides an introductory description on how to use the package. 
For the extended description of the methods, please consult 
Nguyen et al.~\cite{nguyen2015novel}. The bi-level meta-analysis (BLMA) 
framework integrates independent experiments at two levels: an intra-experiment 
analysis, and an inter-experiment analysis. First, for each experiment, 
the intra-experiment analysis splits the dataset into smaller datasets, 
performs a statistical test on each of the newly created small datasets, 
then combines the p-values. Next, the inter-experiment analysis combines 
those processed p-values, from each of the individual experiments. 

In this package, we implement useful functions that allow users to integrate 
data in many applications. First, we implement classical methods for combining 
independent p-values, including Fisher's method~\cite{fisher1925statistical}, 
Stouffer's method~\cite{stouffer1949the}. We also implement our new method 
named addCLT~\cite{nguyen2015novel,nguyen2015DANUBE,nguyen2016overcoming,
nguyen2016tomas}, which is based on the Irwin-Hall 
distribution~\cite{philip1927distribution, irwin1927frequency} and the 
Central Limit Theorem~\cite{kallenberg2002foundations}. These methods of 
combining p-values (addCLT, Fisher's, Stouffer's, minP, and maxP) are the basic 
building blocks of the BLMA framework.

Second, we implement functions for BLMA that can be applied in conjunction 
with classical tests, such as t-test, Wilcoxon test, etc. We provide code 
and examples for applying the intra-experiment analysis and bi-level analysis
in conjunction with t-test and Wilcoxon test. The functions are 
flexible and can be applied for one-sample, two-samples, one-tailed, 
and two-tailed tests. By default, addCLT~\cite{nguyen2015novel,nguyen2015DANUBE,
nguyen2016overcoming,nguyen2016tomas} is used to combine the p-values, 
but users can change it to Fisher's method~\cite{fisher1925statistical}, 
Stouffer's method~\cite{stouffer1949the}, minP~\cite{tippett1931methods}, or 
maxP~\cite{wilkinson1951statistical}, according to their preference.

Third, we implement functions for functional analysis and pathway analysis. 
Users can choose to apply the BLMA framework in conjunction with any of the 
4 methods: 
Over-Representation Analysis (ORA)~\cite{Draghici:2003a,Tavazoie:1999}, 
Gene Set Analysis (GSA)~\cite{Efron:2007}, Pathway Analysis with 
Down-weighting of Overlapping Genes (PADOG)~\cite{Tarca2012down}, 
and Impact Analyis (IA)~\cite{draghici2007systems}. When there is only 
one dataset, the analysis is reduced to an intra-experiment analysis. 
The functions are flexible and easy to run.

Fourth, we implement functions for differential expression analysis. The 
package uses the moderated t-test (limma package~\cite{limma}) as the test for 
differential expression. In the intra-experiment analysis, the framework 
splits a dataset into smaller datasets, performs the moderated t-test 
on these split datasets, and then combines the results. In the 
inter-experiment analysis, the framework combines the results obtained from 
the intra-experiment analysis of individual datasets. The output is a list of 
genes ranked according to how likely they are to be differentially expressed.

\section{BLMA for classical hypothesis testing}
Our bi-level meta-analysis framework is comprised of an intra-experiment and 
an inter-experiment analysis. The reasoning for the intra-experiment is that 
performing a statistical test on a large experiment is not as powerful as 
splitting it into smaller studies and then combining them. 
See Nguyen et al.~\cite{nguyen2015novel} for a detailed explanation.

\subsection{Intra-experiment analysis}
We design the function \emph{intraAnalysisClassic} in a way that it can be 
used in conjunction with classical tests without any restriction. For example,
intead of calling one-sample left-tailed t-test or Wilcoxon test, users can 
call the function \emph{intraAnalysisClassic} with the same parameters. Below
are examples of how to use t-test and Wilcoxon test:

<<>>=
# one-sample tests
library(BLMA)
set.seed(1)
x <- rnorm(10, mean = 0)
# one-sample left-tailed t-test
t.test(x, mu=1, alternative = "less")$p.value
# one-sample left-tailed intra-experiment analysis with t-test
intraAnalysisClassic(x, func=t.test, mu=1, alternative = "less")
# one-sample right-tailed t-test
t.test(x, mu=1, alternative = "greater")$p.value
# one-sample right-tailed intra-experiment analysis with t-test
intraAnalysisClassic(x, func=t.test, mu=1, alternative = "greater")
# one-sample two-tailed t-test
t.test(x, mu=1)$p.value
# one-sample two-tailed intra-experiment analysis with t-test
intraAnalysisClassic(x, func=t.test, mu=1)
# one-sample left-tailed Wilcoxon test
wilcox.test(x, mu=1, alternative = "less")$p.value
# one-sample left-tailed intra-experiment analysis with Wilcoxon test
intraAnalysisClassic(x, func=wilcox.test, mu=1, alternative = "less")
# one-sample right-tailed Wilcoxon test
wilcox.test(x, mu=1, alternative = "greater")$p.value
# one-sample right-tailed intra-experiment analysis with Wilcoxon test
intraAnalysisClassic(x, func=wilcox.test, mu=1, alternative = "greater")
# one-sample two-tailed Wilcoxon test
wilcox.test(x, mu=1)$p.value
# one-sample two-tailed intra-experiment analysis with Wilcoxon test
intraAnalysisClassic(x, func=wilcox.test, mu=1)
@

Similarly, the intra-experiment analysis can be used with two-sample tests:

<<>>=
# two-sample tests
set.seed(1)
x <- rnorm(20, mean=0); y=rnorm(20, mean=1)
# two-sample left-tailed t-test
t.test(x,y,alternative="less")$p.value
# two-sample left-tailed intra-experiment analysis with t-test
intraAnalysisClassic(x, y, func=t.test, alternative = "less")
# two-sample right-tailed t-test
t.test(x,y,alternative="greater")$p.value
# two-sample right-tailed intra-experiment analysis with t-test
intraAnalysisClassic(x, y, func=t.test, alternative = "greater")
# two-sample two-tailed t-test
t.test(x,y)$p.value
# two-sample two-tailed intra-experiment analysis with t-test
intraAnalysisClassic(x, y, func=t.test)
@

\subsection{Bi-level meta-analysis}
Some example code for bi-level meta-analysis:

<<>>=
# one-sample tests
set.seed(1)
l1 <- lapply(as.list(seq(3)),FUN=function (x) rnorm(n=10, mean=1))
l0 <- lapply(as.list(seq(3)),FUN=function (x) rnorm(n=10, mean=0))
# one-sample right-tailed t-test
lapply(l1, FUN=function(x) t.test(x, alternative="greater")$p.value)
# combining the p-values of one-sample t-test:
addCLT(unlist(lapply(l1, FUN=function(x) 
    t.test(x, alternative="greater")$p.value)))
#Bi-level meta-analysis with one-sample right-tailed t-test
bilevelAnalysisClassic(x=l1, func=t.test, alternative="greater")
# two-sample left-tailed t-test
lapply(seq(l1), FUN=function(i,l1,l0) 
    t.test(l1[[i]], l0[[i]], alternative="greater")$p.value, l1, l0)
# combining the p-values of one-sample t-test:
addCLT(unlist(lapply(seq(l1), FUN=function(i,l1,l0) 
    t.test(l1[[i]], l0[[i]], alternative="greater")$p.value, l1, l0)))
#Bi-level meta-analysis with two-sample right-tailed t-test
bilevelAnalysisClassic(x=l1, y=l0, func=t.test, alternative="greater")
#Bi-level meta-analysis with two-sample left-tailed t-test
bilevelAnalysisClassic(x=l1, y=l0, func=t.test, alternative="less")
@


\section{BLMA for geneset/pathway analysis}
For pathway/geneset analysis, the input of the framework is as follows. 
First, we have multiple studies (datasets) of the same disease. Each dataset 
consists of a group of control samples and a group of disease samples. 
Second, we have a list of genesets or pathways from an existing 
pathway database. 

With the current implementation, the meta-analysis can be used in conjunction 
with the following approaches: 
Over-Representation Analysis (ORA)~\cite{Draghici:2003a}, 
Gene Set Analysis (GSA)~\cite{Efron:2007}, Pathway Analysis with 
Down-weighting of Overlapping Genes (PADOG)~\cite{Tarca2012down}, 
and Impact Analyis (IA)~\cite{draghici2007systems}. By default, we use ORA as 
the enrichment method, which is very fast and is able to integrate hundreds 
of samples in a matter of seconds. Other enrichment methods are slower 
than ORA, and we encourage users to take advantage of our parallel computing 
by providing the number of processes via the \emph{mc.cores} parameter. 

\subsection{Over-Representation Analysis (ORA)}

We demonstrate this functionality using 4 acute myeloid leukemia (AML) 
datasets: GSE17054 (9 samples)~\cite{majeti2009dysregulated}, 
GSE57194 (12 samples)~\cite{abdul2010vitro}, 
GSE33223 (30 samples)~\cite{bacher2012multilineage}, and 
GSE42140 (31 samples). 
The platform for all datasets is Affymetrix Human Genome U133 Plus 2.0 array. 
Affymetrix \textit{CEL} files containing raw expression data were downloaded 
from GEO for each dataset and processed using \textit{R} and 
\textit{Bioconductor 2.13}. Quality control was performed using the 
\textit{qc} method from the package 
\textit{simpleaffy 2.38.0}~\cite{simpleaffy2.38.0}. 
Pre-processing was performed on individual datasets using 
the \textit{threestep} function from the package 
\textit{affyPLM version 1.38.0}~\cite{bolstad2004low, bolstad2005quality, 
brettschneider2008quality}. We calculate the expression value of a gene by 
taking the median of the probesets that are mapped to the gene. Below is the 
code for performing BLMA in conjunction with 
ORA~\cite{Draghici:2003a,Tavazoie:1999} for the 4 datasets:

<<>>=
library(BLMA)
# load KEGG pathways and create genesets
x=loadKEGGPathways()
gslist <- lapply(x$kpg,FUN=function(y){return (nodes(y));})
gs.names <- x$kpn[names(gslist)]

# load the 4 AML datasets
dataSets <- c("GSE17054", "GSE57194", "GSE33223", "GSE42140")
data(list=dataSets, package="BLMA")

# prepare dataList and groupList
names(dataSets) <- dataSets
dataList <- lapply(dataSets, function(dataset) get(paste0("data_", dataset)))
groupList <- lapply(dataSets, function(dataset) get(paste0("group_", dataset)))

# perform bi-level meta-analysis in conjunction with ORA
system.time(ORAComb <- bilevelAnalysisGeneset(gslist, gs.names, dataList, 
                                              groupList, enrichment = "ORA"))
#print the results
options(digits=2)
head(ORAComb[, c("Name", "pBLMA", "pBLMA.fdr", "rBLMA")])
@

The running time for ORA is only 4 seconds. With a cutoff of 0.05, there are 
4 significant pathways, among which the target pathway 
\emph{Acute myeloid leukemia} is ranked $3^{rd}$ with a FDR-corrected 
p-value $0.029$.

\subsection{Gene Set Analysis (GSA)}

We can also perform BLMA in conjunction with GSA~\cite{Efron:2007}. Since the 
function GSA (from the GSA package) is not as fast as ORA, we recommend users 
to take advantage of our parallel computing, by setting the number of cores 
using the \emph{mc.cores} parameter:

<<>>=
# perform bi-level meta-analysis in conjunction with GSA
system.time(GSAComb <- bilevelAnalysisGeneset(gslist, gs.names, dataList, 
                                            groupList, enrichment = "GSA", 
                                            nperms=200, random.seed = 1))
#print the results
options(digits=2)
head(GSAComb[, c("Name", "pBLMA", "pBLMA.fdr", "rBLMA")])
@

The running time of the meta-analysis in conjunction with GSA is approximately 
1 minutes with 1 core. With a cutoff of FDR=0.05, there are 2 significant 
pathways: \emph{Apoptosis} and \emph{Acute myeloid leukemia}
. The target pathway  \emph{Acute myeloid leukemia} is ranked $2^{rd}$ with a 
FDR-corrected p-value $0.023$.

\subsection{Pathway Analysis with Down-weighting of Overlapping Genes (PADOG)}
Below is an example code for running BLMA in conjunction with 
PADOG~\cite{Tarca2012down}:

<<>>=
set.seed(1)
system.time(PADOGComb <- bilevelAnalysisGeneset(gslist, gs.names, dataList, 
                                    groupList, enrichment = "PADOG", NI=200))
#print the results
options(digits=2)
head(PADOGComb[, c("Name", "pBLMA", "pBLMA.fdr", "rBLMA")])
@

\subsection{Impact Analysis (IA)}
Impact Analysis (IA) is a topology-based pathway analysis approach that is 
able to take into consideration the interaction between genes~\cite{draghici2007systems}. 
Pathway information can be provided in the format of 
pathway graphs (e.g., graphNEL). Below is an example code for running BLMA 
in conjunction with IA:

<<>>=
x <- loadKEGGPathways()  
system.time(IAComb <- bilevelAnalysisPathway(x$kpg, x$kpn, dataList, groupList))
#print the results
options(digits=2)
head(IAComb[, c("Name", "pBLMA", "pBLMA.fdr", "rBLMA")])
@

\section{BLMA for differential expression analysis}
The package also provides functions for differential expression analysis across 
multiple datasets. The input is a set of datasets from the same condition 
while the output is a list of genes ranked according to their p-values. Here 
we use the moderated t-test (limma package~\cite{limma}) as the test for 
differential expression. As described above, BLMA performs the hypothesis 
testing at two levels: an intra-experiment analysis and an inter-experiment 
analysis. At the intra-experiment analysis, BLMA splits a dataset into smaller 
datasets, performs the moderated t-test for individual genes, 
and then combines the results obtained from these split datasets. 
At the inter-experiment analysis, the processed p-values from 
individual experiments are combined again. By default, the method addCLT is 
used to combine the p-values, but users can set it to Fisher's, 
Stouffer's method, minP, or maxP, according to their preference.

\subsection{Intra-experiment analysis}
The input for intra-experiment analysis is a dataset provided in 
a data frame. The output consists of the following information: 
i) logFC: log foldchanges, 
ii) pLimma: p-values calculated by limma with out intra-experiment analysis, 
iii) FDR-correct p-values of pLimma, 
iv) pIntra: p-values obtained from the intra-experiment analysis, 
and v) FDR-corrected p-values of pIntra. 
The code for analyzing the dataset GSE33223 is as follows:

<<>>=
#perform intra-experiment analysis of the dataset GSE33223 using addCLT
library(BLMA)
data(GSE33223)
system.time(X <- intraAnalysisGene(data_GSE33223, group_GSE33223))
X <- X[order(X$pIntra), ]
# top 10 genes
head(X)
# bottom 10 genes
tail(X)

#perform intra-experiment analysis of GSE33223 using Fisher's method
system.time(Y <- intraAnalysisGene(data_GSE33223, group_GSE33223, 
                      metaMethod=fisherMethod))
Y = Y[order(Y$pIntra), ]
# top 10 genes
head(Y)
# bottom 10 genes
tail(Y)
@

\subsection{Bi-level analysis}
For bi-level analysis, the input is a list of multiple datasets. 
The ouput consists of the following information: i) pLimma: combined 
p-values of limma p-values obtained from individual expriments, 
ii) pLimma.fdr: FDR-correct p-values of pLimma, 
iii) pBilevel: combined p-values of pIntra obtained from individual 
experiments, and iv) pBilevel.fdr: FDR-corrected p-values of pBilevel. 
We demonstrate the bi-level analysis using the 8 example datasets as follows:

<<>>=
system.time(Z <- bilevelAnalysisGene(dataList = dataList, groupList = groupList))

# top 10 genes
head(Z)
# bottom 10 genes
tail(Z)
@

\section{BLMA for network-based integrative analysis}

BLMA also provides a function to estimate the effect sizes of genes across all studies (standardized mean difference) and their p-values. The function also performs classical hypothesis testing and meta-analysis to combine p-values for differential expressed genes across all studies. These statistics can be used as input of both geneset- and network-based analysis \cite{nguyen2020nbia}.

<<>>=
allGenes <- Reduce(intersect, lapply(dataList, rownames))
system.time(geneStat <- getStatistics(allGenes, dataList = dataList, groupList = groupList))

# top 10 genes
head(Z)
# bottom 10 genes
tail(Z)
@

For the details of each column, please consult the documentation of getStatistics function.
<<>>=
?getStatistics
@

Per form pathway analysis
<<>>=
library(ROntoTools)
# get gene network
kpg <- loadKEGGPathways()$kpg
# get gene network name
kpn <- loadKEGGPathways()$kpn
# get geneset
gslist <- lapply(kpg,function(y) nodes(y))

# get differential expressed genes
DEGenes.Left <- rownames(geneStat)[geneStat$pLeft < 0.05 & geneStat$ES.pLeft < 0.05]
DEGenes.Right <- rownames(geneStat)[geneStat$pRight < 0.05 & geneStat$ES.pRight < 0.05]

DEGenes <- union(DEGenes.Left, DEGenes.Right)

# perform pathway analysis with ORA
oraRes <- lapply(gslist, function(gs){
    pORACalc(geneSet = gs, DEGenes = DEGenes, measuredGenes = rownames(geneStat))
})
oraRes <- data.frame(p.value = unlist(oraRes), pathway = names(oraRes))
rownames(oraRes)  <- kpn[rownames(oraRes)]

# print results
print(head(oraRes))

# perfrom pathway analysis with Pathway-Express from ROntoTools
ES <- geneStat[DEGenes, "ES"]
names(ES) <- DEGenes

peRes = pe(x = ES, graphs = kpg, ref = allGenes, nboot = 1000, seed=1, verbose = F)

peRes.Summary <- Summary(peRes, comb.pv.func = fisherMethod)
peRes.Summary[, ncol(peRes.Summary) + 1] <- rownames(peRes.Summary)
rownames(peRes.Summary) <- kpn[rownames(peRes.Summary)]
colnames(peRes.Summary)[ncol(peRes.Summary)] = "pathway"

# print results
print(head(peRes.Summary))
@

% \subsection{Intra-experiment analysis versus t-test}
% Our bi-level meta-analysis framework is comprised of an intra-experiment and 
% an inter-experiment analysis. The reasoning for the intra-experiment is that 
% performing a statistical test on a large experiment is not as powerful as 
% splitting it into smaller studies and then combining them. We demonstrate 
% this using the classical two-sample 
% t-test~\cite{Gossett:1908, pearson1976biometrika}. 

% In this simulation study, we use normal null (control) and alternative 
% (disease) distributions that have the same variance but different means. 
% Analogous to case-control analyses done in biological experiments, we randomly 
% pick a set of samples  from the null distribution and a set of samples  from 
% the alternative distribution and then compare the two sets. We compare  true 
% positive rates (TPR) using two approaches, the two-sample t-test, and a 
% combination of the t-test and our intra-experiment analysis method. For 
% the intra-experiment analysis, we split the disease set into smaller sets of 
% size $5$ to form multiple small studies. We then perform a right-tailed t-test 
% to compare each newly created small disease set against the full control set. 
% The resulting p-values are then combined using addCLT. We will show that a 
% combination of the t-test and the intra-experiment analysis method is more 
% powerful than t-test alone (right-tailed as well).
% 
% Given $n$ as the number of samples, we pick $n$ control samples from $H_0$ and 
% $n$ disease samples from $H_A$. We then use the t-test and the 
% intra-experiment analysis method (combined with t-test) to compare the two 
% sets of samples. Each of the two approaches produces a p-value. We repeat 
% the procedure 100 times to get 100 p-values for the t-test and 100 p-values 
% for the intra-experiment analysis method. We then calculate the true positive 
% rate (TPR) of each method as the number of p-values smaller than the 
% threshold 0.01 divided by 100. 
% 
% <<>>=
% library(BLMA)
% M1=0;M2=0.1
% x <- seq(-3, 3+M1, length=1000); hx <- dnorm(x, mean = M1, sd = 1)
% y2 <- seq(-3, 3+M2, length=1000); hy2 <- dnorm(y2, mean = M2, sd = 1)
% <<label=distribution,include=FALSE>>=
% par(tcl=0.3,mgp=c(1.7,0.4,0),mar=c(3,3,2.5,1), xpd=TRUE)
% plot(x,hx, main="Null and alternative distributions", xlab="x", 
%      ylab="f(x)", cex.axis=1.3,  cex.lab=1.7, cex.main=2, type="l", lwd=2)
% lines(y2, hy2, lwd=2, col="red")
% @
% 
% <<>>=
% set.seed(1)
% threshold=0.01
% M1=0;M2=0.1
% Sizes=seq(5,100,by=5)
% ttestTPR=IntraTPR=NULL
% for (i in 1:length(Sizes)) {
%   pttest=pIntra=NULL
%   for (j in 1:100) {
%     n=Sizes[i]
%     sample1=rnorm(n,M1)
%     sample2=rnorm(n,M2)
%     
%     pttest[j]=t.test(sample2, sample1, alternative = "greater")$p.value
%     pIntra[j]=intraAnalysisClassic(x=sample2, y=sample1, func=t.test, 
%                                    alternative="greater")
%   }
%   ttestTPR[i]=sum(pttest<=threshold)/100
%   IntraTPR[i]=sum(pIntra<=threshold)/100
% }
% lottest <- loess(ttestTPR~Sizes,span=0.5)
% lometa <- loess(IntraTPR~Sizes,span=0.5)
% <<label=IntraTPR,include=FALSE>>=
% par(tcl=0.3,mgp=c(1.7,0.4,0),mar=c(3,3,2.5,1), xpd=TRUE)
% plot(Sizes,predict(lottest), ylim=c(0,max(ttestTPR,IntraTPR)), cex.main=2,
%      main="t-test vs. intra-experiment", cex.axis=1.3,  cex.lab=1.7, type="l", 
%      ylab="True positive rate", xlab="Number of samples", col="blue",lwd=2)
% lines(Sizes,predict(lometa), col='red', lwd=2)
% legend("topleft", legend=c("t-test","Intra-experiment"), 
%        fill=c("blue","red"),cex=1.5)
% @
% 
% \begin{figure}
% \begin{center}
% \resizebox{!}{4in}{
% <<label=fig1,fig=TRUE,echo=FALSE>>=
% <<distribution>>
% @
% }
% \resizebox{!}{4in}{
% <<label=fig2,fig=TRUE,echo=FALSE>>=
% <<IntraTPR>>
% @
% }
% \end{center}
% \caption{The statistical power of the intra-experiment analysis}
% \label{fig:MetaVsTtest}
% \end{figure}
% 
% Figure~\ref{fig:MetaVsTtest} shows a comparison between the t-test and the 
% intra-experiment analysis method. In the top panel of 
% Figure~\ref{fig:MetaVsTtest}, the null distribution $H_0$ (black) is a 
% standard normal distribution with mean $\mu_0=0$ and variance $\sigma_0^{2}=1$ 
% while the alternative distribution $H_A$ (red) has the same variance but 
% different mean, $\mu_A=0.1$. In this case, the alternative distribution is 
% very close to the null distribution and it is hard for hypothesis testing 
% methods to identify whether the samples were drawn from the null or from 
% the alternative distribution.
% 
% The bottom panel of Figure~\ref{fig:MetaVsTtest} displays the true positive 
% rate (TPR) of t-test and of the intra-experiment analysis method. 
% The horizontal axis shows the number of samples while the vertical axis show 
% the TPR. Interestingly, the TPR of the t-test barely increases when the number 
% of samples increases - only from $2\%$ to $5\%$ when the number of samples 
% increases from $20$ to $100$. Similarly, the TPR of the intra-experiment 
% analysis method is also low but it \emph{increases rapidly} when the number 
% of samples increases. For example, the TPR increases from $6\%$ with $20$ 
% samples to $15\%$ with $100$ samples. The figure shows that the TPR of the 
% intra-experiment analysis is approximately three times higher that that of 
% t-test.
% 
% In summary, the intra-experiment analysis method (combined with the t-test) 
% is more powerful than the t-test alone for comparative analysis. 
% As shown in Nguyen et al.~\cite{nguyen2015novel}, the difference in performance 
% between the two approaches increases when the difference between the null and 
% alternative distributions decreases. Therefore, the intra-experiment analysis 
% approach is especially powerful when there is only a small change in gene 
% expression profile between the two phenotypes compared.
% 
% With the same setting, we illustrate the true positive rate (TPR) of the 
% bi-level meta-analysis. In Figure~\ref{fig:BilevelTPR}, the left panel 
% displays the null distribution (black) $H_0$ and the 
% alternative distribution (red) $H_A$. The middle and right panels displays 
% the TPR of the intra-experiment and inter-experiment analyses, respectively. 
% In this case, the TPR is calculated as the number of p-values smaller than 
% the threshold $0.01$ divided by 100. The TPR of the bi-level meta-analysis 
% increases linearly with the number of studies. The TPR increases from $10\%$ 
% with $2$ studies to almost $50\%$ with $20$ studies.
% 
% <<>>=
% set.seed(1)
% BilevelTPR = NULL
% freq=seq(2,50,by=2)
% threshold=0.01
% size=20
% for (i in 1:length(freq)) {
%     pIntra=NULL
%     for (j in 1:100) {
%         l1 = lapply(as.list(seq(freq[i])),FUN=function (x) 
%             rnorm(n=sample(10:100,1), mean=M1))
%         l2 = lapply(as.list(seq(freq[i])),FUN=function (x) 
%             rnorm(n=sample(10:100,1), mean=M2))
%         pIntra[j]=bilevelAnalysisClassic(x=l2,y=l1,func=t.test, 
%                                          alternative="greater")
%     }
%     BilevelTPR[i]=sum(pIntra<threshold)/100
% }
% <<label=BilevelTPR,include=FALSE>>=
% par(tcl=0.3,mgp=c(1.7,0.4,0),mar=c(3,3,2.5,1), xpd=TRUE)
% lo <- loess(BilevelTPR~freq,span=0.5)
% plot(freq,predict(lo), ylim=c(0,1), main="Bi-level meta-analysis", 
%      xlab="Number of studies", ylab="True positive rate", cex.axis=1.3,  
%      cex.lab=1.7, cex.main=2, col="red", type="l", lwd=2)
% @
% 
% \begin{figure} [t]
% \begin{center}
% \resizebox{!}{4in}{
% <<label=fig3,fig=TRUE,echo=FALSE>>=
% <<BilevelTPR>>
% @
% }
% \end{center}
% \caption{The statistical power of the bi-level meta-analysis}
% \label{fig:BilevelTPR}
% \end{figure}

\bibliography{BLMA} 
\bibliographystyle{unsrt_abbrv}
\end{document}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PathwayAnalysis.R
\name{pORACalc}
\alias{pORACalc}
\title{Over-representation Analysis}
\usage{
pORACalc(geneSet, DEGenes, measuredGenes, minSize = 0)
}
\arguments{
\item{geneSet}{a vector of gene names belong to the geneset}

\item{DEGenes}{a vector of differential expressed genes}

\item{measuredGenes}{a vector of all genes in the analysis}

\item{minSize}{the minimum number of DE genes in the geneSet}
}
\value{
p-value
}
\description{
Calculate p-value for over-representation Analysis
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MetaAnalysis.R
\name{addCLT}
\alias{addCLT}
\title{The additive method for meta-analysis}
\usage{
addCLT(x)
}
\arguments{
\item{x}{is an array of independent p-values}
}
\value{
combined p-value
}
\description{
Combine independent studies using the average of p-values
}
\details{
This method is based on the fact that sum of independent uniform variables 
follow the Irwin-Hall distribution [1a,1b]. When the number of p-values 
is small (\emph{n<20}), the distribution of the average of p-values can 
be calculated using a linear transformation of the Irwin-Hall distribution.
When \emph{n} is large, the distribution is approximated using the 
Central Limit Theorem to avoid underflow/overflow problems [2,3,4,5].
}
\examples{

x <- rep(0,10)
addCLT(x)

x <- runif(10)
addCLT(x)

}
\author{
Tin Nguyen and Sorin Draghici
}
\references{
[1a] P. Hall. The distribution of means for samples of size n drawn from a 
population in which the variate takes values between 0 and 1, all such 
values being equally probable. Biometrika, 19(3-4):240-244, 1927.

[1b] J. O. Irwin. On the frequency distribution of the means of samples 
from a population having any law of frequency with finite moments, with 
special reference to Pearson's Type II. Biometrika, 19(3-4):225-239, 1927.

[2] T. Nguyen, R. Tagett, M. Donato, C. Mitrea, and S. Draghici. A novel 
bi-level meta-analysis approach -- applied to biological pathway analysis. 
Bioinformatics, 32(3):409-416, 2016.

[3] T. Nguyen, C. Mitrea, R. Tagett, and S. Draghici. DANUBE: Data-driven 
meta-ANalysis using UnBiased Empirical distributions -- applied to 
biological pathway analysis. Proceedings of the IEEE, PP(99):1-20, 2016.

[4] T. Nguyen, D. Diaz, R. Tagett, and S. Draghici. Overcoming the 
matched-sample bottleneck: an orthogonal approach to integrate omic data. 
Scientific Reports, 6:29251, 2016.

[5] T. Nguyen, D. Diaz, and S. Draghici. TOMAS: A novel TOpology-aware 
Meta-Analysis approach applied to System biology. In Proceedings of the 
7th ACM International Conference on Bioin- formatics, Computational Biology, 
and Health Informatics, pages 13-22. ACM, 2016.
}
\seealso{
\code{\link{fisherMethod}}, \code{\link{stoufferMethod}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MetaAnalysis.R
\name{stoufferMethod}
\alias{stoufferMethod}
\title{Stouffer's method for meta-analysis}
\usage{
stoufferMethod(x)
}
\arguments{
\item{x}{is an array of independent p-values}
}
\value{
combined p-value
}
\description{
Combine independent studies using the sum of p-values 
transformed into standard normal variables
}
\details{
Considering a set of \emph{m} independent significance tests, the resulted 
p-values are independent and uniformly distributed between \emph{0} and 
\emph{1} under the null hypothesis. Stouffer's method is similar to 
Fisher's method (\link{fisherMethod}), with the difference is that it 
uses the sum of p-values transformed into standard normal variables 
instead of the log product.
}
\examples{

x <- rep(0,10)
stoufferMethod(x)

x <- runif(10)
stoufferMethod(x)

}
\author{
Tin Nguyen and Sorin Draghici
}
\references{
[1] S. Stouffer, E. Suchman, L. DeVinney, S. Star, and R. M. Williams. 
The American Soldier: Adjustment during army life, volume 1. 
Princeton University Press, Princeton, 1949.
}
\seealso{
\code{\link{fisherMethod}}, \code{\link{addCLT}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GeneAnalysis.R
\name{bilevelAnalysisClassic}
\alias{bilevelAnalysisClassic}
\title{Bi-level meta-analysis in conjunction with a classical 
hypothesis testing method}
\usage{
bilevelAnalysisClassic(x, y = NULL, splitSize = 5, metaMethod = addCLT,
  func = t.test, p.value = "p.value", ...)
}
\arguments{
\item{x}{a list of numeric vectors}

\item{y}{an optional list of numeric vectors}

\item{splitSize}{the minimum number of size in each split sample. 
splitSize should be at least 3. By default, splitSize=5}

\item{metaMethod}{the method used to combine p-values. This should be one 
of addCLT (additive method [1]), fishersMethod (Fisher's method [5]), 
stoufferMethod (Stouffer's method [6]), max (maxP method [7]), 
or min (minP method [8])}

\item{func}{the name of the hypothesis test. By default func=t.test}

\item{p.value}{the component that returns the p-value after performing the 
test provided by the \emph{func} parameter. For example, the function 
t-test returns the class "htest" where the component "p.value" is the 
p-value of the test. By default, p.value="p.value"}

\item{...}{additional parameters for \emph{func}}
}
\value{
the combined p-value
}
\description{
Perform a bi-level meta-analysis in conjunction with any of 
the classical hypothesis testing methods, such as t-test, Wilcoxon test, etc.
}
\details{
This function performs a bi-level meta-analysis for the lists 
of samples [1]. It performs intra-experiment analyses to compare the 
vectors in x agains the corresponding vectors in y using the function 
\code{\link{intraAnalysisClassic}} in conjunction with the test provided 
in \emph{func}. For example, it compares the first vector in x with the 
first vector in y, the second vector in x with the second vector in y, etc. 
When y is null, then the comparisons are reduced to one-sample tests. After 
these comparisons, we have a list of p-values, one for each comparision. 
The function then combines these p-values to obtain a single p-value 
using \emph{metaMethod}.
}
\examples{
set.seed(1)
l1 <- lapply(as.list(seq(3)),FUN=function (x) rnorm(n=10, mean=1))
l1
# one-sample t-test
lapply(l1, FUN=function(x) t.test(x, alternative="greater")$p.value)
# combining the p-values of one-sample t-tests:
addCLT(unlist(lapply(l1, FUN=function(x) t.test(x, alter="g")$p.value)))
#Bi-level meta-analysis
bilevelAnalysisClassic(x=l1, alternative="greater")
}
\author{
Tin Nguyen and Sorin Draghici
}
\references{
[1] T. Nguyen, R. Tagett, M. Donato, C. Mitrea, and S. Draghici. A novel 
bi-level meta-analysis approach -- applied to biological pathway analysis. 
Bioinformatics, 32(3):409-416, 2016.
}
\seealso{
\code{\link{intraAnalysisClassic}}, \code{\link{intraAnalysisGene}}, \code{\link{bilevelAnalysisGene}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PathwayAnalysis.R
\docType{data}
\name{GSE17054}
\alias{GSE17054}
\alias{data_GSE17054}
\alias{group_GSE17054}
\title{Gene expression dataset GSE17054 from Majeti et al.}
\format{data_GSE17054 is a data frame with 4738 rows and 9 columns. 
The rows represent the genes and the columns represent the samples.

group_GSE17054 is a vector that represents the sample grouping for data_GSE17054. 
The elements of \emph{group_GSE17054} are either 'c' (control) or 'd' (disease).}
\source{
Obtained from \url{http://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE17054}
}
\usage{
data(GSE17054)
}
\description{
This dataset consists of 5 acute myeloid leukemia and 
4 control samples. The data frame data_GSE17054 includes the expression data 
while the vector group_GSE17054 includes the grouping information.
}
\references{
Majeti et al. Dysregulated gene expression networks in human acute 
myelogenous leukemia stem cells. Proceedings of the National Academy of 
Sciences, 106(9):3396-3401, 2009.
}
\keyword{dataset}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GeneAnalysis.R
\name{intraAnalysisGene}
\alias{intraAnalysisGene}
\title{Intra-experiment analysis of an expression dataset at the gene-level}
\usage{
intraAnalysisGene(data, group, splitSize = 5, metaMethod = addCLT)
}
\arguments{
\item{data}{a data frame where the rows are the gene IDs and the 
columns are the samples}

\item{group}{sample grouping. The elements of \emph{group} are 
either 'c' (control) or 'd' (disease). names(group) should be 
identical to colnames(data)}

\item{splitSize}{the minimum number of disease samples in each split 
dataset. splitSize should be at least 3. By default, splitSize=5}

\item{metaMethod}{the method used to combine p-values. This should be one 
of addCLT (additive method [1]), fishersMethod (Fisher's method [5]), 
stoufferMethod (Stouffer's method [6]), max (maxP method [7]), 
or min (minP method [8])}
}
\value{
A data frame (rownames are gene IDs) that consists of the 
following information:
\itemize{
\item \emph{logFC:} log foldchange (diseases versus controls)
\item \emph{pLimma:} p-value obtained from limma without spliting
\item \emph{pLimma.fdr:} FDR-corrected p-values of pLimma
\item \emph{pIntra:} p-value obtained from intra-experiment analysis
\item \emph{pIntra.fdr:} FDR-corrected p-values of pIntra
}
}
\description{
perform an intra-experiment analysis in conjunction with 
the moderated t-test (limma package) for the purpose of differential 
expression analysis of a gene expression dataset
}
\details{
This function performs an intra-experiment analysis [1] for 
individual genes of the given dataset. The function first splits the 
dataset into smaller datasets, performs a moderated t-test (limma package) 
for the genes of the split datasets, 
and then combines the p-values for individual genes using \emph{metaMethod}
}
\examples{
data(GSE33223)
X <- intraAnalysisGene(data_GSE33223, group_GSE33223)
head(X)

}
\author{
Tin Nguyen and Sorin Draghici
}
\references{
[1] T. Nguyen, R. Tagett, M. Donato, C. Mitrea, and S. Draghici. A novel 
bi-level meta-analysis approach -- applied to biological pathway analysis. 
Bioinformatics, 32(3):409-416, 2016.
}
\seealso{
\code{\link{bilevelAnalysisGene}}, \code{\link{intraAnalysisClassic}}, \code{link{bilevelAnalysisClassic}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PathwayAnalysis.R
\name{loadKEGGPathways}
\alias{loadKEGGPathways}
\title{Load KEGG pathways and names}
\usage{
loadKEGGPathways(organism = "hsa", updateCache = FALSE)
}
\arguments{
\item{organism}{organism code. Default value is "hsa" (human)}

\item{updateCache}{re-download KEGG pathways. Default value is FALSE}
}
\value{
A list of the following components
\itemize{
\item \emph{kpg} a list of \code{\link{graphNEL}} objects 
encoding the pathway information. 
\item \emph{kpn} a named vector of pathway tiles. 
The names of the vector are the pathway KEGG IDs.
}
}
\description{
Load KEGG pathways and names
}
\examples{
x <- loadKEGGPathways()
}
\author{
Tin Nguyen and Sorin Draghici
}
\seealso{
\code{\link{keggPathwayGraphs}}, \code{\link{keggPathwayNames}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PathwayAnalysis.R
\docType{data}
\name{GSE42140}
\alias{GSE42140}
\alias{data_GSE42140}
\alias{group_GSE42140}
\title{The gene expression dataset GSE42140 obtained from Gene Expression Omnibus}
\format{data_GSE42140 is a data frame with 4114 rows and 31 columns. 
The rows represent the genes and the columns represent the samples.

group_GSE42140 is a vector that represents the sample grouping for data_GSE42140. 
The elements of \emph{group_GSE42140} are either 'c' (control) or 'd' (disease).}
\usage{
data(GSE42140)
}
\description{
This dataset consists of 26 acute myeloid leukemia and 
5 control samples. The data frame data_GSE42140 includes the expression data 
while the vector group_GSE42140 includes the grouping information.
}
\references{
\url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE42140}
}
\keyword{dataset}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PathwayAnalysis.R
\name{bilevelAnalysisPathway}
\alias{bilevelAnalysisPathway}
\title{Bi-level meta-analysis -- applied to pathway analysis}
\usage{
bilevelAnalysisPathway(kpg, kpn, dataList, groupList, splitSize = 5,
  metaMethod = addCLT, pCutoff = 0.05, percent = 0.05, mc.cores = 1,
  nboot = 200, seed = 1)
}
\arguments{
\item{kpg}{list of pathway graphs as objects of type graph 
(e.g., \code{\link{graphNEL}})}

\item{kpn}{names of the pathways.}

\item{dataList}{a list of datasets to be combined. Each dataset is a data 
frame where the rows are the gene IDs and the columns are the samples.}

\item{groupList}{a list of vectors. Each vector represents the phenotypes 
of the corresponding dataset in dataList, which are either 'c' (control) 
or 'd' (disease).}

\item{splitSize}{the minimum number of disease samples in each split 
dataset. splitSize should be at least 3. By default, splitSize=5}

\item{metaMethod}{the method used to combine p-values. This should be one 
of addCLT (additive method [1]), fisherMethod (Fisher's method [5]), 
stoufferMethod (Stouffer's method [6]), max (maxP method [7]), or 
min (minP method [8])}

\item{pCutoff}{cutoff p-value used to identify differentially 
expressed (DE) genes. This parameter is used only when the enrichment 
method is "ORA". By default, pCutoff=0.05 (five percent)}

\item{percent}{percentage of genes with highest foldchange to be considered 
as differentially expressed (DE). This parameter is used when the enrichment 
method is "ORA". By default percent=0.05 (five percent). Please note that 
only genes with p-value less than pCutoff will be considered}

\item{mc.cores}{the number of cores to be used in parallel computing. 
By default, mc.cores=1}

\item{nboot}{number of bootstrap iterations. By default, nboot=200}

\item{seed}{seed. By default, seed=1.}
}
\value{
A data frame (rownames are geneset/pathway IDs) that consists of the 
following information:
\itemize{
\item \emph{Name:} name/description of the corresponding pathway/geneset
\item Columns that include the pvalues obtained from the intra-experiment 
analysis of individual datasets
\item \emph{pBLMA:} p-value obtained from the inter-experiment 
analysis using addCLT
\item \emph{rBLMA:} ranking of the geneset/pathway using addCLT
\item \emph{pBLMA.fdr:} FDR-corrected p-values
}
}
\description{
Perform a bi-level meta-analysis conjunction with 
Impact Analysis to integrate multiple gene expression datasets
}
\details{
The bi-level framework combines the datasets at two levels: an 
intra-experiment analysis, and an inter-experiment analysis [1]. At the 
intra-level analysis, the framework splits a dataset into smaller datasets, 
performs pathway analysis for each split dataset using 
Impact Analysis [2,3], and then combines the results of these split datasets 
using \emph{metaMethod}. At the inter-level analysis, the results obtained 
for individual datasets are combined using \emph{metaMethod}
}
\examples{
# load KEGG pathways
x <- loadKEGGPathways()  

# load example data
dataSets <- c("GSE17054", "GSE57194", "GSE33223", "GSE42140")
data(list=dataSets, package="BLMA")
names(dataSets) <- dataSets
dataList <- lapply(dataSets, function(dataset) get(paste0("data_", dataset)))
groupList <- lapply(dataSets, function(dataset) get(paste0("group_", dataset)))

IAComb <- bilevelAnalysisPathway(x$kpg, x$kpn, dataList, groupList)
head(IAComb[, c("Name", "pBLMA", "pBLMA.fdr", "rBLMA")])

}
\author{
Tin Nguyen and Sorin Draghici
}
\references{
[1] T. Nguyen, R. Tagett, M. Donato, C. Mitrea, and S. Draghici. A novel 
bi-level meta-analysis approach -- applied to biological pathway analysis. 
Bioinformatics, 32(3):409-416, 2016.

[2] A. L. Tarca, S. Draghici, P. Khatri, S. S. Hassan, P. Mittal, 
J.-s. Kim, C. J. Kim, J. P. Kusanovic, and R. Romero. A novel signaling 
pathway impact analysis. Bioinformatics, 25(1):75-82, 2009.

[3] S. Draghici, P. Khatri, A. L. Tarca, K. Amin, A. Done, C. Voichita, 
C. Georgescu, and R. Romero. A systems biology approach for pathway 
level analysis. Genome Research, 17(10):1537-1545, 2007.

[4] R. A. Fisher. Statistical methods for research workers. 
Oliver & Boyd, Edinburgh, 1925.

[5] S. Stouffer, E. Suchman, L. DeVinney, S. Star, and J. Williams, RM. 
The American Soldier: Adjustment during army life, volume 1. 
Princeton University Press, Princeton, 1949.

[6] L. H. C. Tippett. The methods of statistics. 
The Methods of Statistics, 1931.

[7] B. Wilkinson. A statistical consideration in psychological research. 
Psychological Bulletin, 48(2):156, 1951.
}
\seealso{
\code{\link{bilevelAnalysisGeneset}}, \code{\link{pe}}, \code{\link{phyper}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PathwayAnalysis.R
\docType{data}
\name{GSE57194}
\alias{GSE57194}
\alias{data_GSE57194}
\alias{group_GSE57194}
\title{Gene expression dataset GSE57194 from Abdul-Nabi et al.}
\format{data_GSE57194 is a data frame with 4114 rows and 12 columns. 
The rows represent the genes and the columns represent the samples.

group_GSE57194 is a vector that represents the sample grouping for data_GSE57194. 
The elements of \emph{group_GSE57194} are either 'c' (control) or 'd' (disease).}
\source{
Obtained from \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE57194}
}
\usage{
data(GSE57194)
}
\description{
This dataset consists of 6 acute myeloid leukemia and 
6 control samples. The data frame data_GSE57194 includes the expression data 
while the vector group_GSE57194 includes the grouping information.
}
\references{
Abdul-Nabi et al. In vitro transformation of primary human CD34+ cells by 
AML fusion oncogenes: early gene expression profiling reveals possible drug 
target in AML. PLoS One, 5(8):e12464, 2010.
}
\keyword{dataset}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PathwayAnalysis.R
\name{bilevelAnalysisGeneset}
\alias{bilevelAnalysisGeneset}
\title{Bi-level meta-analysis -- applied to geneset enrichment analysis}
\usage{
bilevelAnalysisGeneset(gslist, gs.names, dataList, groupList, splitSize = 5,
  metaMethod = addCLT, enrichment = "ORA", pCutoff = 0.05,
  percent = 0.05, mc.cores = 1, ...)
}
\arguments{
\item{gslist}{a list of gene sets.}

\item{gs.names}{names of the gene sets.}

\item{dataList}{a list of datasets to be combined. Each dataset is a 
data frame where the rows are the gene IDs and the columns are the samples.}

\item{groupList}{a list of vectors. Each vector represents the phenotypes 
of the corresponding dataset in dataList. 
The elements of each vector are either 'c' (control) or 'd' (disease).}

\item{splitSize}{the minimum number of disease samples in each split 
dataset. splitSize should be at least 3. By default, splitSize=5}

\item{metaMethod}{the method used to combine p-values. This should be one 
of addCLT (additive method [1]), fisherMethod (Fisher's method [5]), 
stoufferMethod (Stouffer's method [6]), max (maxP method [7]), 
or min (minP method [8])}

\item{enrichment}{the method used for enrichment analysis. This should be 
one of "ORA", "GSA", or "PADOG". By default, enrichment is set to "ORA".}

\item{pCutoff}{cutoff p-value used to identify differentially 
expressed (DE) genes. This parameter is used only when the enrichment 
method is "ORA". By default, pCutoff=0.05 (five percent)}

\item{percent}{percentage of genes with highest foldchange to be considered 
as differentially expressed (DE). This parameter is used when the 
enrichment method is "ORA". By default percent=0.05 (five percent). Please 
note that only genes with p-value less than pCutoff will be considered}

\item{mc.cores}{the number of cores to be used in parallel computing. 
By default, mc.cores=1}

\item{...}{additional parameters of the GSA/PADOG functions}
}
\value{
A data frame (rownames are geneset/pathway IDs) that consists of the 
following information:
\itemize{
\item \emph{Name:} name/description of the corresponding pathway/geneset
\item Columns that include the pvalues obtained from the intra-experiment 
analysis of individual datasets
\item \emph{pBLMA:} p-value obtained from the inter-experiment analysis 
using addCLT
\item \emph{rBLMA:} ranking of the geneset/pathway using addCLT
\item \emph{pBLMA.fdr:} FDR-corrected p-values
}
}
\description{
Perform a bi-level meta-analysis in conjunction with 
geneset enrichment methods (ORA/GSA/PADOG) to integrate 
multiple gene expression datasets.
}
\details{
The bi-level framework combines the datasets at two levels: 
an intra- experiment analysis, and an inter-experiment analysis [1]. At the 
intra-level analysis, the framework splits a dataset into smaller datasets, 
performs enrichment analysis for each split dataset (using ORA [2], 
GSA [3], or PADOG [4]), and then combines the results of these split 
datasets using \emph{metaMethod}. At the inter-level analysis, the results 
obtained for individual datasets are combined using \emph{metaMethod}
}
\examples{
# load KEGG pathways and create gene sets
x <- loadKEGGPathways()
gslist <- lapply(x$kpg,FUN=function(y){return (nodes(y));})
gs.names <- x$kpn[names(gslist)]

# load example data
dataSets <- c("GSE17054", "GSE57194", "GSE33223", "GSE42140")
data(list=dataSets, package="BLMA")
names(dataSets) <- dataSets
dataList <- lapply(dataSets, function(dataset) get(paste0("data_", dataset)))
groupList <- lapply(dataSets, function(dataset) get(paste0("group_", dataset)))
# perform bi-level meta-analysis in conjunction with ORA
ORAComb <- bilevelAnalysisGeneset(gslist, gs.names, dataList, groupList, enrichment = "ORA")
head(ORAComb[, c("Name", "pBLMA", "pBLMA.fdr", "rBLMA")])

# perform bi-level meta-analysis in conjunction with GSA
GSAComb <- bilevelAnalysisGeneset(gslist, gs.names, dataList, groupList, enrichment = "GSA", nperms = 200, random.seed = 1)
head(GSAComb[, c("Name", "pBLMA", "pBLMA.fdr", "rBLMA")])

# perform bi-level meta-analysi in conjunction with PADOG
set.seed(1)
PADOGComb <- bilevelAnalysisGeneset(gslist, gs.names, dataList, groupList, enrichment = "PADOG", NI=200)
head(PADOGComb[, c("Name", "pBLMA", "pBLMA.fdr", "rBLMA")])

}
\author{
Tin Nguyen and Sorin Draghici
}
\references{
[1] T. Nguyen, R. Tagett, M. Donato, C. Mitrea, and S. Draghici. A novel 
bi-level meta-analysis approach -- applied to biological pathway analysis. 
Bioinformatics, 32(3):409-416, 2016.

[2] S. Draghici, P. Khatri, R. P. Martin, G. C. Ostermeier, and 
S. A. Krawetz. Global functional profiling of gene expression. 
Genomics, 81(2):98-104, 2003.

[3] B. Efron and R. Tibshirani. On testing the significance of sets of 
genes. The Annals of Applied Statistics, 1(1):107-129, 2007.

[4] A. L. Tarca, S. Draghici, G. Bhatti, and R. Romero. Down-weighting 
overlapping genes improves gene set analysis. 
BMC Bioinformatics, 13(1):136, 2012.

[5] R. A. Fisher. Statistical methods for research workers. 
Oliver & Boyd, Edinburgh, 1925.

[6] S. Stouffer, E. Suchman, L. DeVinney, S. Star, and J. Williams, RM. 
The American Soldier: Adjustment during army life, volume 1. 
Princeton University Press, Princeton, 1949.

[7] L. H. C. Tippett. The methods of statistics. 
The Methods of Statistics, 1931.

[8] B. Wilkinson. A statistical consideration in psychological research. 
Psychological Bulletin, 48(2):156, 1951.
}
\seealso{
\code{\link{bilevelAnalysisPathway}}, \code{\link{phyper}}, \code{\link{GSA}}, \code{\link{padog}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/IntegrativeAnalysis.R
\name{getStatistics}
\alias{getStatistics}
\title{Intergrative genes statistic}
\usage{
getStatistics(allGenes, dataList, groupList, ncores = 1, method = addCLT)
}
\arguments{
\item{allGenes}{Vector of all genes names for the analysis.}

\item{dataList}{A list of expression matrices, in which rows are genes and columns are samples.}

\item{groupList}{A list of vectors indicating sample group corresponding with expression matrices in dataList.}

\item{ncores}{Number of core to use in prallel processing.}

\item{method}{Function for combining p-values. It must accept one input which is a vector of p-values and return a combined p-value. Three methods are embeded in this package are addCLT, fisherMethod, and stoufferMethod.}
}
\value{
A data.frame of gene statistics with following columns:

\describe{
  \item{pTwoTails}{Two-tailed p-values}
  \item{pTwoTails.fdr}{Two-tailed p-values with false discovery rate correction}
  \item{pLeft}{left-tailed p-values}
  \item{pLeft.fdr}{left-tailed p-values with false discovery rate correction}
  \item{pRight.fdr}{right-tailed p-values with false discovery rate correction}
  \item{pRight}{right-tailed p-values}
  \item{ES}{Effect size}
  \item{ES.pTwoTails}{Two-tailed p-values for effect size}
  \item{ES.pTwoTails.fdr}{Two-tailed p-values for effect size with false discovery rate correction}
  \item{ES.pLeft}{Left-tailed p-values for effect size}
  \item{ES.pLeft.fdr}{Left-tailed p-values for effect size with false discovery rate correction}
  \item{ES.pRight}{Right-tailed p-values for effect size}
  \item{ES.pRight.fdr}{Right-tailed p-values for effect size with false discovery rate correction}
}
}
\description{
Calculate genes summary statistic across multiple datasets
}
\details{
To estimate the effect sizes of genes across all studies, first standardized mean difference 
for each gene in individual studies is compute. Next, the overall efect size and standard error are estimated using
the random-efects model. This overall efect size represents the gene's expression change under the efect of
the condition. The, z-scores and p-values of observing such efect sizes are computed. The p-values is obtained 
from classical hypothesis testing. By default, linear model and empirical Bayesian testing \(limma\) are used 
to compute the p-values for diferential expression. The two-tailed p-values are converted to one-tailed p-values (lef- and right-tailed). 
For each gene, the one-tailed p-values across all datasets are then combined using the addCLT, stouffer or fisher method.
These p-values represent how likely the diferential expression is observed by chance.
}
\examples{

datasets <- c("GSE17054", "GSE57194", "GSE33223", "GSE42140")
data(list = datasets, package = "BLMA")
dataList <- lapply(datasets, function(dataset) {
    get(paste0("data_", dataset))
})
groupList <- lapply(datasets, function(dataset) {
    get(paste0("group_", dataset))
})
names(dataList) <- datasets
names(groupList) <- datasets

allGenes <- Reduce(intersect, lapply(dataList, rownames))

geneStat <- getStatistics(allGenes, dataList, groupList)
head(geneStat)

# perform pathway analysis
library(ROntoTools)
# get gene network
kpg <- loadKEGGPathways()$kpg
# get gene network name
kpn <- loadKEGGPathways()$kpn
# get geneset
gslist <- lapply(kpg,function(y) nodes(y))

# get differential expressed genes
DEGenes.Left <- rownames(geneStat)[geneStat$pLeft < 0.05 & geneStat$ES.pLeft < 0.05]
DEGenes.Right <- rownames(geneStat)[geneStat$pRight < 0.05 & geneStat$ES.pRight < 0.05]

DEGenes <- union(DEGenes.Left, DEGenes.Right)

# perform pathway analysis with ORA
oraRes <- lapply(gslist, function(gs){
    pORACalc(geneSet = gs, DEGenes = DEGenes, measuredGenes = rownames(geneStat))
})
oraRes <- data.frame(p.value = unlist(oraRes), pathway = names(oraRes))
rownames(oraRes)  <- kpn[rownames(oraRes)]

# print results
print(head(oraRes))

# perfrom pathway analysis with Pathway-Express from ROntoTools
ES <- geneStat[DEGenes, "ES"]
names(ES) <- DEGenes

peRes = pe(x = ES, graphs = kpg, ref = allGenes, nboot = 1000, seed=1)

peRes.Summary <- Summary(peRes, comb.pv.func = fisherMethod)
peRes.Summary[, ncol(peRes.Summary) + 1] <- rownames(peRes.Summary)
rownames(peRes.Summary) <- kpn[rownames(peRes.Summary)]
colnames(peRes.Summary)[ncol(peRes.Summary)] = "pathway"

# print results
print(head(peRes.Summary))

}
\references{
Nguyen, T., Shafi, A., Nguyen, T. M., Schissler, A. G., & Draghici, S. (2020). NBIA: a network-based integrative analysis framework-applied to pathway analysis. Scientific reports, 10(1), 1-11.
Nguyen, T., Tagett, R., Donato, M., Mitrea, C., & Draghici, S. (2016). A novel bi-level meta-analysis approach: applied to biological pathway analysis. Bioinformatics, 32(3), 409-416.
Smyth, G. K. (2005). Limma: linear models for microarray data. In Bioinformatics and computational biology solutions using R and Bioconductor (pp. 397-420). Springer, New York, NY.
}
\seealso{
\code{\link{addCLT}}
}
\author{
Tin Nguyen, Hung Nguyen, and Sorin Draghici
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MetaAnalysis.R
\name{fisherMethod}
\alias{fisherMethod}
\title{Fisher's method for meta-analysis}
\usage{
fisherMethod(x)
}
\arguments{
\item{x}{is an array of independent p-values}
}
\value{
combined p-value
}
\description{
Combine independent p-values using the minus log product
}
\details{
Considering a set of \emph{m} independent significance tests, the resulted 
p-values are independent and uniformly distributed between \emph{0} and 
\emph{1} under the null hypothesis. Fisher's method uses the minus 
log product of the p-values as the summary statistic, which follows a 
chi-square distribution with \emph{2m} degrees of freedom. 
This chi-square distribution is used to calculate the combined p-value.
}
\examples{

x <- rep(0,10)
fisherMethod(x)

x <- runif(10)
fisherMethod(x)

}
\author{
Tin Nguyen and Sorin Draghici
}
\references{
[1] R. A. Fisher. Statistical methods for research workers. 
Oliver & Boyd, Edinburgh, 1925.
}
\seealso{
\code{\link{stoufferMethod}}, \code{\link{addCLT}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PathwayAnalysis.R
\docType{data}
\name{GSE33223}
\alias{GSE33223}
\alias{data_GSE33223}
\alias{group_GSE33223}
\title{Gene expression dataset GSE33223 from Bacher et al.}
\format{data_GSE33223 is a data frame with 4114 rows and 30 columns. 
The rows represent the genes and the columns represent the samples.

group_GSE33223 is a vector that represents the sample grouping for 
data_GSE33223. The elements of \emph{group_GSE33223} are either 
'c' (control) or 'd' (disease).}
\source{
Obtained from \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE33223}
}
\usage{
data(GSE33223)
}
\description{
This dataset consists of 20 acute myeloid leukemia and 
10 control samples. The data frame data_GSE33223 includes the expression data 
while the vector group_GSE33223 includes the grouping information.
}
\references{
Bacher et al. Multilineage dysplasia does not influence prognosis in 
CEBPA-mutated AML, supporting the WHO proposal to classify these patients 
as a unique entity. Blood, 119(20):4719-22, 2012.
}
\keyword{dataset}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GeneAnalysis.R
\name{intraAnalysisClassic}
\alias{intraAnalysisClassic}
\title{Intra-experiment analysis in conjunction with classical 
hypothesis tests}
\usage{
intraAnalysisClassic(x, y = NULL, splitSize = 5, metaMethod = addCLT,
  func = t.test, p.value = "p.value", ...)
}
\arguments{
\item{x}{a numeric vector of data values}

\item{y}{an optional numeric vector of values}

\item{splitSize}{the minimum number of size in each split sample. 
splitSize should be at least 3. By default, splitSize=5}

\item{metaMethod}{the method used to combine p-values. This should be one 
of addCLT (additive method [1]), fishersMethod (Fisher's method [5]), 
stoufferMethod (Stouffer's method [6]), max (maxP method [7]), 
or min (minP method [8])}

\item{func}{the name of the hypothesis test. By default func=t.test}

\item{p.value}{the component that returns the p-value after performing 
the test provided by the \emph{func} parameter. For example, the function 
t-test returns the class "htest" where the component "p.value" is the 
p-value of the test. By default, p.value="p.value"}

\item{...}{additional parameters for \emph{func}}
}
\value{
intra-experiment p-value
}
\description{
Perform an intra-experiment analysis in conjunction with any 
of the classical hypothesis testing methods, such as t-test, 
Wilcoxon test, etc.
}
\details{
This function performs an intra-experiment analysis for the given 
sample(s) [1]. Given x as the numeric vector, this function first splits x 
into smaller samples with size \emph{splitSize}, performs hypothesis 
testing using \emph{func}, and then combines the p-values 
using \emph{metaMethod}
}
\examples{
set.seed(1)
x <- rnorm(10, mean = 0)
# p-value obtained from a one-sample t-test
t.test(x, mu=1, alternative = "less")$p.value
# p-value obtained from an intra-experiment analysis
intraAnalysisClassic(x, func=t.test, mu=1, alternative = "less")

# p-value obtained from a one-sample wilcoxon test
wilcox.test(x, mu=1, alternative = "less")$p.value
# p-value obtained from an intra-experiment analysis
intraAnalysisClassic(x, func=wilcox.test, mu=1, alternative = "less")

set.seed(1)
x <- rnorm(20, mean=0); y <- rnorm(20, mean=1)
# p-value obtained from a two-sample t-test
t.test(x,y,alternative="less")$p.value
# p-value obtained from an intra-experiment analysis
intraAnalysisClassic(x, y, func=t.test, alternative = "less")
# p-value obtained from a two-sample wilcoxon test
wilcox.test(x,y,alternative="less")$p.value
# p-value obtained from an intra-experiment analysis
intraAnalysisClassic(x, y, func=wilcox.test, alternative = "less")

}
\author{
Tin Nguyen and Sorin Draghici
}
\references{
[1] T. Nguyen, R. Tagett, M. Donato, C. Mitrea, and S. Draghici. A novel 
bi-level meta-analysis approach -- applied to biological pathway analysis. 
Bioinformatics, 32(3):409-416, 2016.
}
\seealso{
\code{\link{bilevelAnalysisClassic}}, \code{\link{intraAnalysisGene}}, \code{\link{bilevelAnalysisGene}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GeneAnalysis.R
\name{bilevelAnalysisGene}
\alias{bilevelAnalysisGene}
\title{Bi-level meta-analysis of multiple expression datasets at the 
gene-level}
\usage{
bilevelAnalysisGene(dataList, groupList, splitSize = 5, metaMethod = addCLT)
}
\arguments{
\item{dataList}{a list of datasets. Each dataset is a data frame where the 
rows are the gene IDs and the columns are the samples}

\item{groupList}{a list of vectors. Each vector represents the phenotypes 
of the corresponding dataset in dataList, 
which are either 'c' (control) or 'd' (disease).}

\item{splitSize}{the minimum number of disease samples in each split 
dataset. splitSize should be at least 3. By default, splitSize=5}

\item{metaMethod}{the method used to combine p-values. This should be one 
of addCLT (additive method [1]), 
fishersMethod (Fisher's method [5]), stoufferMethod (Stouffer's method [6]), 
max (maxP method [7]), or min (minP method [8])}
}
\value{
A data frame containing the following components:
\itemize{
\item \emph{rownames:} gene IDs that are common in all datasets
\item \emph{pLimma:} the p-values obtained by combining pLimma 
values of individual datasets
\item \emph{pLimma.fdr:} FDR-corrected p-values of pLimma
\item \emph{pBilevel:} the p-values obtained from combining pIntra 
values of individual datasets
\item \emph{pBilevel.fdr:} FDR-corrected p-values of pBilevel
}
}
\description{
Perform a bi-level meta-analysis in conjunction with the 
moderate t-test (limma package) for the purpose of 
differential expression analysis of multiple gene expression datasets
}
\details{
The bi-level framework combines the datasets at two levels: an 
intra- experiment analysis, and an inter-experiment analysis [1]. At the 
intra-experiment analysis, the framework splits a dataset into 
smaller datasets, performs a moderated t-test (limma package) on split 
datasets, and then combines p-values of individual genes 
using \emph{metaMethod}. At the inter-experiment analysis, the p-values 
obtained for each individual datasets are combined using \emph{metaMethod}
}
\examples{
dataSets <- c("GSE17054", "GSE57194", "GSE33223", "GSE42140")
data(list=dataSets, package="BLMA")
names(dataSets) <- dataSets
dataList <- lapply(dataSets, function(dataset) get(paste0("data_", dataset)))
groupList <- lapply(dataSets, function(dataset) get(paste0("group_", dataset)))
Z <- bilevelAnalysisGene(dataList = dataList, groupList = groupList)
head(Z)

}
\author{
Tin Nguyen and Sorin Draghici
}
\references{
[1] T. Nguyen, R. Tagett, M. Donato, C. Mitrea, and S. Draghici. A novel 
bi-level meta-analysis approach -- applied to biological pathway analysis. 
Bioinformatics, 32(3):409-416, 2016.
}
\seealso{
\code{\link{bilevelAnalysisGene}}, \code{\link{intraAnalysisClassic}}
}
